
# ApiYarnApplication

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**allocatedMB** | [**BigDecimal**](BigDecimal.md) | The sum of memory in MB allocated to the application&#39;s running containers Available since v12. |  [optional]
**allocatedVCores** | [**BigDecimal**](BigDecimal.md) | The sum of virtual cores allocated to the application&#39;s running containers Available since v12. |  [optional]
**runningContainers** | [**BigDecimal**](BigDecimal.md) | The number of containers currently running for the application Available since v12. |  [optional]
**applicationTags** | **List&lt;String&gt;** | List of YARN application tags. Available since v12. |  [optional]
**allocatedMemorySeconds** | [**BigDecimal**](BigDecimal.md) | Allocated memory to the application in units of mb-secs. Available since v12. |  [optional]
**allocatedVcoreSeconds** | [**BigDecimal**](BigDecimal.md) | Allocated vcore-secs to the application. Available since v12. |  [optional]
**applicationId** | **String** | The application id. |  [optional]
**name** | **String** | The name of the application. |  [optional]
**startTime** | **String** | The time the application was submitted. |  [optional]
**endTime** | **String** | The time the application finished. If the application hasn&#39;t finished this will return null. |  [optional]
**user** | **String** | The user who submitted the application. |  [optional]
**pool** | **String** | The pool the application was submitted to. |  [optional]
**progress** | [**BigDecimal**](BigDecimal.md) | The progress, as a percentage, the application has made. This is only set if the application is currently executing. |  [optional]
**attributes** | **Map&lt;String, String&gt;** | A map of additional application attributes which is generated by Cloudera Manager. For example MR2 job counters are exposed as key/value pairs here. For more details see the Cloudera Manager documentation. |  [optional]
**mr2AppInformation** | [**ApiMr2AppInformation**](ApiMr2AppInformation.md) |  |  [optional]
**state** | **String** |  |  [optional]
**containerUsedMemorySeconds** | [**BigDecimal**](BigDecimal.md) | Actual memory (in MB-secs) used by containers launched by the YARN application. Computed by running a MapReduce job from Cloudera Service Monitor to aggregate YARN usage metrics. Available since v12. |  [optional]
**containerUsedMemoryMax** | [**BigDecimal**](BigDecimal.md) | Maximum memory used by containers launched by the YARN application. Computed by running a MapReduce job from Cloudera Service Monitor to aggregate YARN usage metrics Available since v16 |  [optional]
**containerUsedCpuSeconds** | [**BigDecimal**](BigDecimal.md) | Actual CPU (in percent-secs) used by containers launched by the YARN application. Computed by running a MapReduce job from Cloudera Service Monitor to aggregate YARN usage metrics. Available since v12. |  [optional]
**containerUsedVcoreSeconds** | [**BigDecimal**](BigDecimal.md) | Actual VCore-secs used by containers launched by the YARN application. Computed by running a MapReduce job from Cloudera Service Monitor to aggregate YARN usage metrics. Available since v12. |  [optional]
**containerAllocatedMemorySeconds** | [**BigDecimal**](BigDecimal.md) | Total memory (in mb-secs) allocated to containers launched by the YARN application. Computed by running a MapReduce job from Cloudera Service Monitor to aggregate YARN usage metrics. Available since v12. |  [optional]
**containerAllocatedVcoreSeconds** | [**BigDecimal**](BigDecimal.md) | Total vcore-secs allocated to containers launched by the YARN application. Computed by running a MapReduce job from Cloudera Service Monitor to aggregate YARN usage metrics. Available since v12. |  [optional]



