# AuthServiceRoleConfigGroupsResourceApi

All URIs are relative to *https://localhost/api/v33*

Method | HTTP request | Description
------------- | ------------- | -------------
[**readConfig**](AuthServiceRoleConfigGroupsResourceApi.md#readConfig) | **GET** /cm/authService/roleConfigGroups/{roleConfigGroupName}/config | Returns the current revision of the config for the specified role config group in the Authentication Service.
[**readRoleConfigGroup**](AuthServiceRoleConfigGroupsResourceApi.md#readRoleConfigGroup) | **GET** /cm/authService/roleConfigGroups/{roleConfigGroupName} | Returns the information for a given role config group in the Authentication Service.
[**readRoleConfigGroups**](AuthServiceRoleConfigGroupsResourceApi.md#readRoleConfigGroups) | **GET** /cm/authService/roleConfigGroups | Returns the information for all role config groups in the Authentication Service.
[**readRoles**](AuthServiceRoleConfigGroupsResourceApi.md#readRoles) | **GET** /cm/authService/roleConfigGroups/{roleConfigGroupName}/roles | Returns all roles in the given role config group in the Authentication Service.
[**updateConfig**](AuthServiceRoleConfigGroupsResourceApi.md#updateConfig) | **PUT** /cm/authService/roleConfigGroups/{roleConfigGroupName}/config | Updates the config for the given role config group in the Authentication Service.
[**updateRoleConfigGroup**](AuthServiceRoleConfigGroupsResourceApi.md#updateRoleConfigGroup) | **PUT** /cm/authService/roleConfigGroups/{roleConfigGroupName} | Updates an existing role config group in the Authentication Service.


<a name="readConfig"></a>
# **readConfig**
> ApiConfigList readConfig(roleConfigGroupName, view)

Returns the current revision of the config for the specified role config group in the Authentication Service.

Returns the current revision of the config for the specified role config group in the Authentication Service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.AuthServiceRoleConfigGroupsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

AuthServiceRoleConfigGroupsResourceApi apiInstance = new AuthServiceRoleConfigGroupsResourceApi();
String roleConfigGroupName = "roleConfigGroupName_example"; // String | The name of the role config group.
String view = "summary"; // String | The view of the data to materialize, either \"summary\" or \"full\".
try {
    ApiConfigList result = apiInstance.readConfig(roleConfigGroupName, view);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceRoleConfigGroupsResourceApi#readConfig");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **roleConfigGroupName** | **String**| The name of the role config group. |
 **view** | **String**| The view of the data to materialize, either \"summary\" or \"full\". | [optional] [default to summary] [enum: EXPORT, EXPORT_REDACTED, FULL, FULL_WITH_HEALTH_CHECK_EXPLANATION, SUMMARY]

### Return type

[**ApiConfigList**](ApiConfigList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readRoleConfigGroup"></a>
# **readRoleConfigGroup**
> ApiRoleConfigGroup readRoleConfigGroup(roleConfigGroupName)

Returns the information for a given role config group in the Authentication Service.

Returns the information for a given role config group in the Authentication Service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.AuthServiceRoleConfigGroupsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

AuthServiceRoleConfigGroupsResourceApi apiInstance = new AuthServiceRoleConfigGroupsResourceApi();
String roleConfigGroupName = "roleConfigGroupName_example"; // String | The name of the requested group.
try {
    ApiRoleConfigGroup result = apiInstance.readRoleConfigGroup(roleConfigGroupName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceRoleConfigGroupsResourceApi#readRoleConfigGroup");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **roleConfigGroupName** | **String**| The name of the requested group. |

### Return type

[**ApiRoleConfigGroup**](ApiRoleConfigGroup.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readRoleConfigGroups"></a>
# **readRoleConfigGroups**
> ApiRoleConfigGroupList readRoleConfigGroups()

Returns the information for all role config groups in the Authentication Service.

Returns the information for all role config groups in the Authentication Service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.AuthServiceRoleConfigGroupsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

AuthServiceRoleConfigGroupsResourceApi apiInstance = new AuthServiceRoleConfigGroupsResourceApi();
try {
    ApiRoleConfigGroupList result = apiInstance.readRoleConfigGroups();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceRoleConfigGroupsResourceApi#readRoleConfigGroups");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ApiRoleConfigGroupList**](ApiRoleConfigGroupList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readRoles"></a>
# **readRoles**
> ApiRoleList readRoles(roleConfigGroupName)

Returns all roles in the given role config group in the Authentication Service.

Returns all roles in the given role config group in the Authentication Service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.AuthServiceRoleConfigGroupsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

AuthServiceRoleConfigGroupsResourceApi apiInstance = new AuthServiceRoleConfigGroupsResourceApi();
String roleConfigGroupName = "roleConfigGroupName_example"; // String | The name of the role config group.
try {
    ApiRoleList result = apiInstance.readRoles(roleConfigGroupName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceRoleConfigGroupsResourceApi#readRoles");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **roleConfigGroupName** | **String**| The name of the role config group. |

### Return type

[**ApiRoleList**](ApiRoleList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateConfig"></a>
# **updateConfig**
> ApiConfigList updateConfig(roleConfigGroupName, message, body)

Updates the config for the given role config group in the Authentication Service.

Updates the config for the given role config group in the Authentication Service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.AuthServiceRoleConfigGroupsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

AuthServiceRoleConfigGroupsResourceApi apiInstance = new AuthServiceRoleConfigGroupsResourceApi();
String roleConfigGroupName = "roleConfigGroupName_example"; // String | The name of the role config group.
String message = "message_example"; // String | Optional message describing the changes.
ApiConfigList body = new ApiConfigList(); // ApiConfigList | The new config information for the group.
try {
    ApiConfigList result = apiInstance.updateConfig(roleConfigGroupName, message, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceRoleConfigGroupsResourceApi#updateConfig");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **roleConfigGroupName** | **String**| The name of the role config group. |
 **message** | **String**| Optional message describing the changes. | [optional]
 **body** | [**ApiConfigList**](ApiConfigList.md)| The new config information for the group. | [optional]

### Return type

[**ApiConfigList**](ApiConfigList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateRoleConfigGroup"></a>
# **updateRoleConfigGroup**
> ApiRoleConfigGroup updateRoleConfigGroup(roleConfigGroupName, message, body)

Updates an existing role config group in the Authentication Service.

Updates an existing role config group in the Authentication Service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.AuthServiceRoleConfigGroupsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

AuthServiceRoleConfigGroupsResourceApi apiInstance = new AuthServiceRoleConfigGroupsResourceApi();
String roleConfigGroupName = "roleConfigGroupName_example"; // String | The name of the group to update.
String message = "message_example"; // String | The optional message describing the changes.
ApiRoleConfigGroup body = new ApiRoleConfigGroup(); // ApiRoleConfigGroup | The updated role config group.
try {
    ApiRoleConfigGroup result = apiInstance.updateRoleConfigGroup(roleConfigGroupName, message, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceRoleConfigGroupsResourceApi#updateRoleConfigGroup");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **roleConfigGroupName** | **String**| The name of the group to update. |
 **message** | **String**| The optional message describing the changes. | [optional]
 **body** | [**ApiRoleConfigGroup**](ApiRoleConfigGroup.md)| The updated role config group. | [optional]

### Return type

[**ApiRoleConfigGroup**](ApiRoleConfigGroup.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

