/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiCallback;
import com.cloudera.api.swagger.client.ApiClient;
import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.client.ApiResponse;
import com.cloudera.api.swagger.client.Configuration;
import com.cloudera.api.swagger.client.Pair;
import com.cloudera.api.swagger.client.ProgressRequestBody;
import com.cloudera.api.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.cloudera.api.swagger.model.ApiCommand;
import com.cloudera.api.swagger.model.ApiReplicationCommandList;
import com.cloudera.api.swagger.model.ApiReplicationDiagnosticsCollectionArgs;
import com.cloudera.api.swagger.model.ApiReplicationSchedule;
import com.cloudera.api.swagger.model.ApiReplicationScheduleList;
import com.cloudera.api.swagger.model.ApiReplicationState;
import java.math.BigDecimal;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ReplicationsResourceApi {
    private ApiClient apiClient;

    public ReplicationsResourceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ReplicationsResourceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for collectDiagnosticData
     * @param clusterName  (required)
     * @param scheduleId Schedule ID (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @param body Replication collection arguments (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call collectDiagnosticDataCall(String clusterName, BigDecimal scheduleId, String serviceName, String view, ApiReplicationDiagnosticsCollectionArgs body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/collectDiagnosticData"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "scheduleId" + "\\}", apiClient.escapeString(scheduleId.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (view != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "view", view));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call collectDiagnosticDataValidateBeforeCall(String clusterName, BigDecimal scheduleId, String serviceName, String view, ApiReplicationDiagnosticsCollectionArgs body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling collectDiagnosticData(Async)");
        }
        
        // verify the required parameter 'scheduleId' is set
        if (scheduleId == null) {
            throw new ApiException("Missing the required parameter 'scheduleId' when calling collectDiagnosticData(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling collectDiagnosticData(Async)");
        }
        
        
        com.squareup.okhttp.Call call = collectDiagnosticDataCall(clusterName, scheduleId, serviceName, view, body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.  The returned command&#39;s resultDataUrl property, upon the commands completion, will refer to the generated diagnostic data. Available since API v11.
     * @param clusterName  (required)
     * @param scheduleId Schedule ID (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @param body Replication collection arguments (optional)
     * @return ApiCommand
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiCommand collectDiagnosticData(String clusterName, BigDecimal scheduleId, String serviceName, String view, ApiReplicationDiagnosticsCollectionArgs body) throws ApiException {
        ApiResponse<ApiCommand> resp = collectDiagnosticDataWithHttpInfo(clusterName, scheduleId, serviceName, view, body);
        return resp.getData();
    }

    /**
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.  The returned command&#39;s resultDataUrl property, upon the commands completion, will refer to the generated diagnostic data. Available since API v11.
     * @param clusterName  (required)
     * @param scheduleId Schedule ID (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @param body Replication collection arguments (optional)
     * @return ApiResponse&lt;ApiCommand&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiCommand> collectDiagnosticDataWithHttpInfo(String clusterName, BigDecimal scheduleId, String serviceName, String view, ApiReplicationDiagnosticsCollectionArgs body) throws ApiException {
        com.squareup.okhttp.Call call = collectDiagnosticDataValidateBeforeCall(clusterName, scheduleId, serviceName, view, body, null, null);
        Type localVarReturnType = new TypeToken<ApiCommand>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID. (asynchronously)
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.  The returned command&#39;s resultDataUrl property, upon the commands completion, will refer to the generated diagnostic data. Available since API v11.
     * @param clusterName  (required)
     * @param scheduleId Schedule ID (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @param body Replication collection arguments (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call collectDiagnosticDataAsync(String clusterName, BigDecimal scheduleId, String serviceName, String view, ApiReplicationDiagnosticsCollectionArgs body, final ApiCallback<ApiCommand> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = collectDiagnosticDataValidateBeforeCall(clusterName, scheduleId, serviceName, view, body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiCommand>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createSchedules
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body List of the replication schedules to create. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createSchedulesCall(String clusterName, String serviceName, ApiReplicationScheduleList body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createSchedulesValidateBeforeCall(String clusterName, String serviceName, ApiReplicationScheduleList body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling createSchedules(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling createSchedules(Async)");
        }
        
        
        com.squareup.okhttp.Call call = createSchedulesCall(clusterName, serviceName, body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Creates one or more replication schedules.
     * Creates one or more replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body List of the replication schedules to create. (optional)
     * @return ApiReplicationScheduleList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationScheduleList createSchedules(String clusterName, String serviceName, ApiReplicationScheduleList body) throws ApiException {
        ApiResponse<ApiReplicationScheduleList> resp = createSchedulesWithHttpInfo(clusterName, serviceName, body);
        return resp.getData();
    }

    /**
     * Creates one or more replication schedules.
     * Creates one or more replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body List of the replication schedules to create. (optional)
     * @return ApiResponse&lt;ApiReplicationScheduleList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationScheduleList> createSchedulesWithHttpInfo(String clusterName, String serviceName, ApiReplicationScheduleList body) throws ApiException {
        com.squareup.okhttp.Call call = createSchedulesValidateBeforeCall(clusterName, serviceName, body, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationScheduleList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Creates one or more replication schedules. (asynchronously)
     * Creates one or more replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body List of the replication schedules to create. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createSchedulesAsync(String clusterName, String serviceName, ApiReplicationScheduleList body, final ApiCallback<ApiReplicationScheduleList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createSchedulesValidateBeforeCall(clusterName, serviceName, body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationScheduleList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteAllSchedules
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteAllSchedulesCall(String clusterName, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteAllSchedulesValidateBeforeCall(String clusterName, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling deleteAllSchedules(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling deleteAllSchedules(Async)");
        }
        
        
        com.squareup.okhttp.Call call = deleteAllSchedulesCall(clusterName, serviceName, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Deletes all existing replication schedules.
     * Deletes all existing replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @return ApiReplicationScheduleList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationScheduleList deleteAllSchedules(String clusterName, String serviceName) throws ApiException {
        ApiResponse<ApiReplicationScheduleList> resp = deleteAllSchedulesWithHttpInfo(clusterName, serviceName);
        return resp.getData();
    }

    /**
     * Deletes all existing replication schedules.
     * Deletes all existing replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @return ApiResponse&lt;ApiReplicationScheduleList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationScheduleList> deleteAllSchedulesWithHttpInfo(String clusterName, String serviceName) throws ApiException {
        com.squareup.okhttp.Call call = deleteAllSchedulesValidateBeforeCall(clusterName, serviceName, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationScheduleList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Deletes all existing replication schedules. (asynchronously)
     * Deletes all existing replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteAllSchedulesAsync(String clusterName, String serviceName, final ApiCallback<ApiReplicationScheduleList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteAllSchedulesValidateBeforeCall(clusterName, serviceName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationScheduleList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteSchedule
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteScheduleCall(String clusterName, BigDecimal scheduleId, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "scheduleId" + "\\}", apiClient.escapeString(scheduleId.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteScheduleValidateBeforeCall(String clusterName, BigDecimal scheduleId, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling deleteSchedule(Async)");
        }
        
        // verify the required parameter 'scheduleId' is set
        if (scheduleId == null) {
            throw new ApiException("Missing the required parameter 'scheduleId' when calling deleteSchedule(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling deleteSchedule(Async)");
        }
        
        
        com.squareup.okhttp.Call call = deleteScheduleCall(clusterName, scheduleId, serviceName, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Deletes an existing replication schedule.
     * Deletes an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @return ApiReplicationSchedule
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationSchedule deleteSchedule(String clusterName, BigDecimal scheduleId, String serviceName) throws ApiException {
        ApiResponse<ApiReplicationSchedule> resp = deleteScheduleWithHttpInfo(clusterName, scheduleId, serviceName);
        return resp.getData();
    }

    /**
     * Deletes an existing replication schedule.
     * Deletes an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @return ApiResponse&lt;ApiReplicationSchedule&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationSchedule> deleteScheduleWithHttpInfo(String clusterName, BigDecimal scheduleId, String serviceName) throws ApiException {
        com.squareup.okhttp.Call call = deleteScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationSchedule>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Deletes an existing replication schedule. (asynchronously)
     * Deletes an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteScheduleAsync(String clusterName, BigDecimal scheduleId, String serviceName, final ApiCallback<ApiReplicationSchedule> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationSchedule>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReplicationState
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReplicationStateCall(String clusterName, String serviceName, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/replicationState"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (view != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "view", view));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReplicationStateValidateBeforeCall(String clusterName, String serviceName, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling getReplicationState(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling getReplicationState(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getReplicationStateCall(clusterName, serviceName, view, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * returns the replication state.
     * returns the replication state. for example if incremental export is enabled, etc
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @return ApiReplicationState
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationState getReplicationState(String clusterName, String serviceName, String view) throws ApiException {
        ApiResponse<ApiReplicationState> resp = getReplicationStateWithHttpInfo(clusterName, serviceName, view);
        return resp.getData();
    }

    /**
     * returns the replication state.
     * returns the replication state. for example if incremental export is enabled, etc
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @return ApiResponse&lt;ApiReplicationState&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationState> getReplicationStateWithHttpInfo(String clusterName, String serviceName, String view) throws ApiException {
        com.squareup.okhttp.Call call = getReplicationStateValidateBeforeCall(clusterName, serviceName, view, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationState>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * returns the replication state. (asynchronously)
     * returns the replication state. for example if incremental export is enabled, etc
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view view to materialize (optional, default to summary)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReplicationStateAsync(String clusterName, String serviceName, String view, final ApiCallback<ApiReplicationState> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReplicationStateValidateBeforeCall(clusterName, serviceName, view, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationState>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for readHistory
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param limit Maximum number of commands to retrieve. (optional, default to 20)
     * @param offset Index of first command to retrieve. (optional, default to 0)
     * @param view The view to materialize. (optional, default to summary)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call readHistoryCall(String clusterName, BigDecimal scheduleId, String serviceName, Integer limit, Integer offset, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/history"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "scheduleId" + "\\}", apiClient.escapeString(scheduleId.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));
        if (view != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "view", view));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call readHistoryValidateBeforeCall(String clusterName, BigDecimal scheduleId, String serviceName, Integer limit, Integer offset, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling readHistory(Async)");
        }
        
        // verify the required parameter 'scheduleId' is set
        if (scheduleId == null) {
            throw new ApiException("Missing the required parameter 'scheduleId' when calling readHistory(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling readHistory(Async)");
        }
        
        
        com.squareup.okhttp.Call call = readHistoryCall(clusterName, scheduleId, serviceName, limit, offset, view, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Returns a list of commands triggered by a schedule.
     * Returns a list of commands triggered by a schedule.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param limit Maximum number of commands to retrieve. (optional, default to 20)
     * @param offset Index of first command to retrieve. (optional, default to 0)
     * @param view The view to materialize. (optional, default to summary)
     * @return ApiReplicationCommandList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationCommandList readHistory(String clusterName, BigDecimal scheduleId, String serviceName, Integer limit, Integer offset, String view) throws ApiException {
        ApiResponse<ApiReplicationCommandList> resp = readHistoryWithHttpInfo(clusterName, scheduleId, serviceName, limit, offset, view);
        return resp.getData();
    }

    /**
     * Returns a list of commands triggered by a schedule.
     * Returns a list of commands triggered by a schedule.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param limit Maximum number of commands to retrieve. (optional, default to 20)
     * @param offset Index of first command to retrieve. (optional, default to 0)
     * @param view The view to materialize. (optional, default to summary)
     * @return ApiResponse&lt;ApiReplicationCommandList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationCommandList> readHistoryWithHttpInfo(String clusterName, BigDecimal scheduleId, String serviceName, Integer limit, Integer offset, String view) throws ApiException {
        com.squareup.okhttp.Call call = readHistoryValidateBeforeCall(clusterName, scheduleId, serviceName, limit, offset, view, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationCommandList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a list of commands triggered by a schedule. (asynchronously)
     * Returns a list of commands triggered by a schedule.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param limit Maximum number of commands to retrieve. (optional, default to 20)
     * @param offset Index of first command to retrieve. (optional, default to 0)
     * @param view The view to materialize. (optional, default to summary)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call readHistoryAsync(String clusterName, BigDecimal scheduleId, String serviceName, Integer limit, Integer offset, String view, final ApiCallback<ApiReplicationCommandList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = readHistoryValidateBeforeCall(clusterName, scheduleId, serviceName, limit, offset, view, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationCommandList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for readSchedule
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param view The view to materialize. (optional, default to summary)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call readScheduleCall(String clusterName, BigDecimal scheduleId, String serviceName, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "scheduleId" + "\\}", apiClient.escapeString(scheduleId.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (view != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "view", view));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call readScheduleValidateBeforeCall(String clusterName, BigDecimal scheduleId, String serviceName, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling readSchedule(Async)");
        }
        
        // verify the required parameter 'scheduleId' is set
        if (scheduleId == null) {
            throw new ApiException("Missing the required parameter 'scheduleId' when calling readSchedule(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling readSchedule(Async)");
        }
        
        
        com.squareup.okhttp.Call call = readScheduleCall(clusterName, scheduleId, serviceName, view, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Returns information for a specific replication schedule.
     * Returns information for a specific replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param view The view to materialize. (optional, default to summary)
     * @return ApiReplicationSchedule
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationSchedule readSchedule(String clusterName, BigDecimal scheduleId, String serviceName, String view) throws ApiException {
        ApiResponse<ApiReplicationSchedule> resp = readScheduleWithHttpInfo(clusterName, scheduleId, serviceName, view);
        return resp.getData();
    }

    /**
     * Returns information for a specific replication schedule.
     * Returns information for a specific replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param view The view to materialize. (optional, default to summary)
     * @return ApiResponse&lt;ApiReplicationSchedule&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationSchedule> readScheduleWithHttpInfo(String clusterName, BigDecimal scheduleId, String serviceName, String view) throws ApiException {
        com.squareup.okhttp.Call call = readScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, view, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationSchedule>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns information for a specific replication schedule. (asynchronously)
     * Returns information for a specific replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param view The view to materialize. (optional, default to summary)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call readScheduleAsync(String clusterName, BigDecimal scheduleId, String serviceName, String view, final ApiCallback<ApiReplicationSchedule> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = readScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, view, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationSchedule>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for readSchedules
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view provides summary or detailed view, default is summary (optional, default to summary)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call readSchedulesCall(String clusterName, String serviceName, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (view != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "view", view));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call readSchedulesValidateBeforeCall(String clusterName, String serviceName, String view, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling readSchedules(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling readSchedules(Async)");
        }
        
        
        com.squareup.okhttp.Call call = readSchedulesCall(clusterName, serviceName, view, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Returns information for all replication schedules.
     * Returns information for all replication schedules. &lt;p&gt; Available since API v32.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view provides summary or detailed view, default is summary (optional, default to summary)
     * @return ApiReplicationScheduleList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationScheduleList readSchedules(String clusterName, String serviceName, String view) throws ApiException {
        ApiResponse<ApiReplicationScheduleList> resp = readSchedulesWithHttpInfo(clusterName, serviceName, view);
        return resp.getData();
    }

    /**
     * Returns information for all replication schedules.
     * Returns information for all replication schedules. &lt;p&gt; Available since API v32.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view provides summary or detailed view, default is summary (optional, default to summary)
     * @return ApiResponse&lt;ApiReplicationScheduleList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationScheduleList> readSchedulesWithHttpInfo(String clusterName, String serviceName, String view) throws ApiException {
        com.squareup.okhttp.Call call = readSchedulesValidateBeforeCall(clusterName, serviceName, view, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationScheduleList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns information for all replication schedules. (asynchronously)
     * Returns information for all replication schedules. &lt;p&gt; Available since API v32.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param view provides summary or detailed view, default is summary (optional, default to summary)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call readSchedulesAsync(String clusterName, String serviceName, String view, final ApiCallback<ApiReplicationScheduleList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = readSchedulesValidateBeforeCall(clusterName, serviceName, view, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationScheduleList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for runCopyListing
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call runCopyListingCall(String clusterName, String serviceName, String body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/hdfsCopyListing"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call runCopyListingValidateBeforeCall(String clusterName, String serviceName, String body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling runCopyListing(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling runCopyListing(Async)");
        }
        
        
        com.squareup.okhttp.Call call = runCopyListingCall(clusterName, serviceName, body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Run the hdfs copy listing command.
     * Run the hdfs copy listing command &lt;p&gt; The copy listing command will be triggered with the provided arguments &lt;p&gt; Available since API v18. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @return ApiCommand
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiCommand runCopyListing(String clusterName, String serviceName, String body) throws ApiException {
        ApiResponse<ApiCommand> resp = runCopyListingWithHttpInfo(clusterName, serviceName, body);
        return resp.getData();
    }

    /**
     * Run the hdfs copy listing command.
     * Run the hdfs copy listing command &lt;p&gt; The copy listing command will be triggered with the provided arguments &lt;p&gt; Available since API v18. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @return ApiResponse&lt;ApiCommand&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiCommand> runCopyListingWithHttpInfo(String clusterName, String serviceName, String body) throws ApiException {
        com.squareup.okhttp.Call call = runCopyListingValidateBeforeCall(clusterName, serviceName, body, null, null);
        Type localVarReturnType = new TypeToken<ApiCommand>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Run the hdfs copy listing command. (asynchronously)
     * Run the hdfs copy listing command &lt;p&gt; The copy listing command will be triggered with the provided arguments &lt;p&gt; Available since API v18. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call runCopyListingAsync(String clusterName, String serviceName, String body, final ApiCallback<ApiCommand> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = runCopyListingValidateBeforeCall(clusterName, serviceName, body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiCommand>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for runSchedule
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param dryRun Whether to execute a dry run. (optional, default to false)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call runScheduleCall(String clusterName, BigDecimal scheduleId, String serviceName, Boolean dryRun, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/run"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "scheduleId" + "\\}", apiClient.escapeString(scheduleId.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (dryRun != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "dryRun", dryRun));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call runScheduleValidateBeforeCall(String clusterName, BigDecimal scheduleId, String serviceName, Boolean dryRun, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling runSchedule(Async)");
        }
        
        // verify the required parameter 'scheduleId' is set
        if (scheduleId == null) {
            throw new ApiException("Missing the required parameter 'scheduleId' when calling runSchedule(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling runSchedule(Async)");
        }
        
        
        com.squareup.okhttp.Call call = runScheduleCall(clusterName, scheduleId, serviceName, dryRun, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Run the schedule immediately.
     * Run the schedule immediately. &lt;p&gt; The replication command will be triggered with the configured arguments, and will be recorded in the schedule&#39;s history. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param dryRun Whether to execute a dry run. (optional, default to false)
     * @return ApiCommand
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiCommand runSchedule(String clusterName, BigDecimal scheduleId, String serviceName, Boolean dryRun) throws ApiException {
        ApiResponse<ApiCommand> resp = runScheduleWithHttpInfo(clusterName, scheduleId, serviceName, dryRun);
        return resp.getData();
    }

    /**
     * Run the schedule immediately.
     * Run the schedule immediately. &lt;p&gt; The replication command will be triggered with the configured arguments, and will be recorded in the schedule&#39;s history. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param dryRun Whether to execute a dry run. (optional, default to false)
     * @return ApiResponse&lt;ApiCommand&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiCommand> runScheduleWithHttpInfo(String clusterName, BigDecimal scheduleId, String serviceName, Boolean dryRun) throws ApiException {
        com.squareup.okhttp.Call call = runScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, dryRun, null, null);
        Type localVarReturnType = new TypeToken<ApiCommand>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Run the schedule immediately. (asynchronously)
     * Run the schedule immediately. &lt;p&gt; The replication command will be triggered with the configured arguments, and will be recorded in the schedule&#39;s history. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param dryRun Whether to execute a dry run. (optional, default to false)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call runScheduleAsync(String clusterName, BigDecimal scheduleId, String serviceName, Boolean dryRun, final ApiCallback<ApiCommand> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = runScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, dryRun, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiCommand>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateSchedule
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateScheduleCall(String clusterName, BigDecimal scheduleId, String serviceName, ApiReplicationSchedule body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "scheduleId" + "\\}", apiClient.escapeString(scheduleId.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateScheduleValidateBeforeCall(String clusterName, BigDecimal scheduleId, String serviceName, ApiReplicationSchedule body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling updateSchedule(Async)");
        }
        
        // verify the required parameter 'scheduleId' is set
        if (scheduleId == null) {
            throw new ApiException("Missing the required parameter 'scheduleId' when calling updateSchedule(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling updateSchedule(Async)");
        }
        
        
        com.squareup.okhttp.Call call = updateScheduleCall(clusterName, scheduleId, serviceName, body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Updates an existing replication schedule.
     * Updates an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @return ApiReplicationSchedule
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiReplicationSchedule updateSchedule(String clusterName, BigDecimal scheduleId, String serviceName, ApiReplicationSchedule body) throws ApiException {
        ApiResponse<ApiReplicationSchedule> resp = updateScheduleWithHttpInfo(clusterName, scheduleId, serviceName, body);
        return resp.getData();
    }

    /**
     * Updates an existing replication schedule.
     * Updates an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @return ApiResponse&lt;ApiReplicationSchedule&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiReplicationSchedule> updateScheduleWithHttpInfo(String clusterName, BigDecimal scheduleId, String serviceName, ApiReplicationSchedule body) throws ApiException {
        com.squareup.okhttp.Call call = updateScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, body, null, null);
        Type localVarReturnType = new TypeToken<ApiReplicationSchedule>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Updates an existing replication schedule. (asynchronously)
     * Updates an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     * @param clusterName  (required)
     * @param scheduleId Id of an existing replication schedule. (required)
     * @param serviceName The service name. (required)
     * @param body  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateScheduleAsync(String clusterName, BigDecimal scheduleId, String serviceName, ApiReplicationSchedule body, final ApiCallback<ApiReplicationSchedule> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateScheduleValidateBeforeCall(clusterName, scheduleId, serviceName, body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiReplicationSchedule>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
