/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiCallback;
import com.cloudera.api.swagger.client.ApiClient;
import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.client.ApiResponse;
import com.cloudera.api.swagger.client.Configuration;
import com.cloudera.api.swagger.client.Pair;
import com.cloudera.api.swagger.client.ProgressRequestBody;
import com.cloudera.api.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.cloudera.api.swagger.model.ApiEcho;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ToolsResourceApi {
    private ApiClient apiClient;

    public ToolsResourceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ToolsResourceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for echo
     * @param message The message to echo back (optional, default to Hello, World!)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call echoCall(String message, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/tools/echo";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (message != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "message", message));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call echoValidateBeforeCall(String message, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = echoCall(message, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Echoes the provided message back to the caller.
     * Echoes the provided message back to the caller.
     * @param message The message to echo back (optional, default to Hello, World!)
     * @return ApiEcho
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiEcho echo(String message) throws ApiException {
        ApiResponse<ApiEcho> resp = echoWithHttpInfo(message);
        return resp.getData();
    }

    /**
     * Echoes the provided message back to the caller.
     * Echoes the provided message back to the caller.
     * @param message The message to echo back (optional, default to Hello, World!)
     * @return ApiResponse&lt;ApiEcho&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiEcho> echoWithHttpInfo(String message) throws ApiException {
        com.squareup.okhttp.Call call = echoValidateBeforeCall(message, null, null);
        Type localVarReturnType = new TypeToken<ApiEcho>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Echoes the provided message back to the caller. (asynchronously)
     * Echoes the provided message back to the caller.
     * @param message The message to echo back (optional, default to Hello, World!)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call echoAsync(String message, final ApiCallback<ApiEcho> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = echoValidateBeforeCall(message, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiEcho>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for echoError
     * @param message The error message to echo (optional, default to Default error message)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call echoErrorCall(String message, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/tools/echoError";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (message != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "message", message));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call echoErrorValidateBeforeCall(String message, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = echoErrorCall(message, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Throws an error containing the given input message.
     * Throws an error containing the given input message. This is what an error response looks like.  &lt;pre&gt;    {      \&quot;message\&quot;: \&quot;An error message\&quot;,      \&quot;causes\&quot;: [ \&quot;A list of causes\&quot;, \&quot;Potentially null\&quot; ]    }  &lt;/pre&gt;  &lt;p&gt;The &lt;em&gt;message&lt;/em&gt; field contains a description of the error. The &lt;em&gt;causes&lt;/em&gt; field, if not null, contains a list of causes for the error. &lt;/p&gt;  &lt;p&gt;Note that this &lt;strong&gt;never&lt;/strong&gt; returns an echoMessage. Instead, the result (and all error results) has the above structure. &lt;/p&gt;
     * @param message The error message to echo (optional, default to Default error message)
     * @return ApiEcho
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiEcho echoError(String message) throws ApiException {
        ApiResponse<ApiEcho> resp = echoErrorWithHttpInfo(message);
        return resp.getData();
    }

    /**
     * Throws an error containing the given input message.
     * Throws an error containing the given input message. This is what an error response looks like.  &lt;pre&gt;    {      \&quot;message\&quot;: \&quot;An error message\&quot;,      \&quot;causes\&quot;: [ \&quot;A list of causes\&quot;, \&quot;Potentially null\&quot; ]    }  &lt;/pre&gt;  &lt;p&gt;The &lt;em&gt;message&lt;/em&gt; field contains a description of the error. The &lt;em&gt;causes&lt;/em&gt; field, if not null, contains a list of causes for the error. &lt;/p&gt;  &lt;p&gt;Note that this &lt;strong&gt;never&lt;/strong&gt; returns an echoMessage. Instead, the result (and all error results) has the above structure. &lt;/p&gt;
     * @param message The error message to echo (optional, default to Default error message)
     * @return ApiResponse&lt;ApiEcho&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiEcho> echoErrorWithHttpInfo(String message) throws ApiException {
        com.squareup.okhttp.Call call = echoErrorValidateBeforeCall(message, null, null);
        Type localVarReturnType = new TypeToken<ApiEcho>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Throws an error containing the given input message. (asynchronously)
     * Throws an error containing the given input message. This is what an error response looks like.  &lt;pre&gt;    {      \&quot;message\&quot;: \&quot;An error message\&quot;,      \&quot;causes\&quot;: [ \&quot;A list of causes\&quot;, \&quot;Potentially null\&quot; ]    }  &lt;/pre&gt;  &lt;p&gt;The &lt;em&gt;message&lt;/em&gt; field contains a description of the error. The &lt;em&gt;causes&lt;/em&gt; field, if not null, contains a list of causes for the error. &lt;/p&gt;  &lt;p&gt;Note that this &lt;strong&gt;never&lt;/strong&gt; returns an echoMessage. Instead, the result (and all error results) has the above structure. &lt;/p&gt;
     * @param message The error message to echo (optional, default to Default error message)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call echoErrorAsync(String message, final ApiCallback<ApiEcho> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = echoErrorValidateBeforeCall(message, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiEcho>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
