/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiCallback;
import com.cloudera.api.swagger.client.ApiClient;
import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.client.ApiResponse;
import com.cloudera.api.swagger.client.Configuration;
import com.cloudera.api.swagger.client.Pair;
import com.cloudera.api.swagger.client.ProgressRequestBody;
import com.cloudera.api.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.cloudera.api.swagger.model.ApiWatchedDir;
import com.cloudera.api.swagger.model.ApiWatchedDirList;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class WatchedDirResourceApi {
    private ApiClient apiClient;

    public WatchedDirResourceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public WatchedDirResourceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for addWatchedDirectory
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body The directory to be added. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call addWatchedDirectoryCall(String clusterName, String serviceName, ApiWatchedDir body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/watcheddir"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call addWatchedDirectoryValidateBeforeCall(String clusterName, String serviceName, ApiWatchedDir body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling addWatchedDirectory(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling addWatchedDirectory(Async)");
        }
        
        
        com.squareup.okhttp.Call call = addWatchedDirectoryCall(clusterName, serviceName, body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Adds a directory to the watching list.
     * Adds a directory to the watching list. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body The directory to be added. (optional)
     * @return ApiWatchedDir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiWatchedDir addWatchedDirectory(String clusterName, String serviceName, ApiWatchedDir body) throws ApiException {
        ApiResponse<ApiWatchedDir> resp = addWatchedDirectoryWithHttpInfo(clusterName, serviceName, body);
        return resp.getData();
    }

    /**
     * Adds a directory to the watching list.
     * Adds a directory to the watching list. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body The directory to be added. (optional)
     * @return ApiResponse&lt;ApiWatchedDir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiWatchedDir> addWatchedDirectoryWithHttpInfo(String clusterName, String serviceName, ApiWatchedDir body) throws ApiException {
        com.squareup.okhttp.Call call = addWatchedDirectoryValidateBeforeCall(clusterName, serviceName, body, null, null);
        Type localVarReturnType = new TypeToken<ApiWatchedDir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Adds a directory to the watching list. (asynchronously)
     * Adds a directory to the watching list. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param body The directory to be added. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call addWatchedDirectoryAsync(String clusterName, String serviceName, ApiWatchedDir body, final ApiCallback<ApiWatchedDir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = addWatchedDirectoryValidateBeforeCall(clusterName, serviceName, body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiWatchedDir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listWatchedDirectories
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call listWatchedDirectoriesCall(String clusterName, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/watcheddir"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call listWatchedDirectoriesValidateBeforeCall(String clusterName, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling listWatchedDirectories(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling listWatchedDirectories(Async)");
        }
        
        
        com.squareup.okhttp.Call call = listWatchedDirectoriesCall(clusterName, serviceName, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Lists all the watched directories.
     * Lists all the watched directories. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @return ApiWatchedDirList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiWatchedDirList listWatchedDirectories(String clusterName, String serviceName) throws ApiException {
        ApiResponse<ApiWatchedDirList> resp = listWatchedDirectoriesWithHttpInfo(clusterName, serviceName);
        return resp.getData();
    }

    /**
     * Lists all the watched directories.
     * Lists all the watched directories. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @return ApiResponse&lt;ApiWatchedDirList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiWatchedDirList> listWatchedDirectoriesWithHttpInfo(String clusterName, String serviceName) throws ApiException {
        com.squareup.okhttp.Call call = listWatchedDirectoriesValidateBeforeCall(clusterName, serviceName, null, null);
        Type localVarReturnType = new TypeToken<ApiWatchedDirList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Lists all the watched directories. (asynchronously)
     * Lists all the watched directories. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param serviceName The service name. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listWatchedDirectoriesAsync(String clusterName, String serviceName, final ApiCallback<ApiWatchedDirList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listWatchedDirectoriesValidateBeforeCall(clusterName, serviceName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiWatchedDirList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for removeWatchedDirectory
     * @param clusterName  (required)
     * @param directoryPath The directory path to be removed. (required)
     * @param serviceName The service name. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call removeWatchedDirectoryCall(String clusterName, String directoryPath, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/clusters/{clusterName}/services/{serviceName}/watcheddir/{directoryPath}"
            .replaceAll("\\{" + "clusterName" + "\\}", apiClient.escapeString(clusterName.toString()))
            .replaceAll("\\{" + "directoryPath" + "\\}", apiClient.escapeString(directoryPath.toString()))
            .replaceAll("\\{" + "serviceName" + "\\}", apiClient.escapeString(serviceName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call removeWatchedDirectoryValidateBeforeCall(String clusterName, String directoryPath, String serviceName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling removeWatchedDirectory(Async)");
        }
        
        // verify the required parameter 'directoryPath' is set
        if (directoryPath == null) {
            throw new ApiException("Missing the required parameter 'directoryPath' when calling removeWatchedDirectory(Async)");
        }
        
        // verify the required parameter 'serviceName' is set
        if (serviceName == null) {
            throw new ApiException("Missing the required parameter 'serviceName' when calling removeWatchedDirectory(Async)");
        }
        
        
        com.squareup.okhttp.Call call = removeWatchedDirectoryCall(clusterName, directoryPath, serviceName, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Removes a directory from the watching list.
     * Removes a directory from the watching list. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param directoryPath The directory path to be removed. (required)
     * @param serviceName The service name. (required)
     * @return ApiWatchedDir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiWatchedDir removeWatchedDirectory(String clusterName, String directoryPath, String serviceName) throws ApiException {
        ApiResponse<ApiWatchedDir> resp = removeWatchedDirectoryWithHttpInfo(clusterName, directoryPath, serviceName);
        return resp.getData();
    }

    /**
     * Removes a directory from the watching list.
     * Removes a directory from the watching list. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param directoryPath The directory path to be removed. (required)
     * @param serviceName The service name. (required)
     * @return ApiResponse&lt;ApiWatchedDir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiWatchedDir> removeWatchedDirectoryWithHttpInfo(String clusterName, String directoryPath, String serviceName) throws ApiException {
        com.squareup.okhttp.Call call = removeWatchedDirectoryValidateBeforeCall(clusterName, directoryPath, serviceName, null, null);
        Type localVarReturnType = new TypeToken<ApiWatchedDir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Removes a directory from the watching list. (asynchronously)
     * Removes a directory from the watching list. &lt;p&gt; Available since API v14. Only available with Cloudera Manager Enterprise Edition. &lt;p&gt;
     * @param clusterName  (required)
     * @param directoryPath The directory path to be removed. (required)
     * @param serviceName The service name. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call removeWatchedDirectoryAsync(String clusterName, String directoryPath, String serviceName, final ApiCallback<ApiWatchedDir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = removeWatchedDirectoryValidateBeforeCall(clusterName, directoryPath, serviceName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiWatchedDir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
