/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * Host templates will contain information about the role config groups that should be applied to a host. This basically means a host will have a role corresponding to each config group.
 */
@ApiModel(description = "Host templates will contain information about the role config groups that should be applied to a host. This basically means a host will have a role corresponding to each config group.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-09-25T07:41:36.316Z")
public class ApiClusterTemplateHostTemplate {
  @SerializedName("refName")
  private String refName = null;

  @SerializedName("roleConfigGroupsRefNames")
  private List<String> roleConfigGroupsRefNames = null;

  @SerializedName("cardinality")
  private BigDecimal cardinality = null;

  public ApiClusterTemplateHostTemplate refName(String refName) {
    this.refName = refName;
    return this;
  }

   /**
   * Reference name
   * @return refName
  **/
  @ApiModelProperty(value = "Reference name")
  public String getRefName() {
    return refName;
  }

  public void setRefName(String refName) {
    this.refName = refName;
  }

  public ApiClusterTemplateHostTemplate roleConfigGroupsRefNames(List<String> roleConfigGroupsRefNames) {
    this.roleConfigGroupsRefNames = roleConfigGroupsRefNames;
    return this;
  }

  public ApiClusterTemplateHostTemplate addRoleConfigGroupsRefNamesItem(String roleConfigGroupsRefNamesItem) {
    if (this.roleConfigGroupsRefNames == null) {
      this.roleConfigGroupsRefNames = new ArrayList<String>();
    }
    this.roleConfigGroupsRefNames.add(roleConfigGroupsRefNamesItem);
    return this;
  }

   /**
   * List of role config groups
   * @return roleConfigGroupsRefNames
  **/
  @ApiModelProperty(example = "\"null\"", value = "List of role config groups")
  public List<String> getRoleConfigGroupsRefNames() {
    return roleConfigGroupsRefNames;
  }

  public void setRoleConfigGroupsRefNames(List<String> roleConfigGroupsRefNames) {
    this.roleConfigGroupsRefNames = roleConfigGroupsRefNames;
  }

  public ApiClusterTemplateHostTemplate cardinality(BigDecimal cardinality) {
    this.cardinality = cardinality;
    return this;
  }

   /**
   * Represent the cardinality of this host template on source
   * @return cardinality
  **/
  @ApiModelProperty(value = "Represent the cardinality of this host template on source")
  public BigDecimal getCardinality() {
    return cardinality;
  }

  public void setCardinality(BigDecimal cardinality) {
    this.cardinality = cardinality;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiClusterTemplateHostTemplate apiClusterTemplateHostTemplate = (ApiClusterTemplateHostTemplate) o;
    return Objects.equals(this.refName, apiClusterTemplateHostTemplate.refName) &&
        Objects.equals(this.roleConfigGroupsRefNames, apiClusterTemplateHostTemplate.roleConfigGroupsRefNames) &&
        Objects.equals(this.cardinality, apiClusterTemplateHostTemplate.cardinality);
  }

  @Override
  public int hashCode() {
    return Objects.hash(refName, roleConfigGroupsRefNames, cardinality);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiClusterTemplateHostTemplate {\n");
    
    sb.append("    refName: ").append(toIndentedString(refName)).append("\n");
    sb.append("    roleConfigGroupsRefNames: ").append(toIndentedString(roleConfigGroupsRefNames)).append("\n");
    sb.append("    cardinality: ").append(toIndentedString(cardinality)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

