/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiTenantUtilizationList;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * Utilization report information of a Cluster.
 */
@ApiModel(description = "Utilization report information of a Cluster.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-09-25T07:41:36.316Z")
public class ApiClusterUtilization {
  @SerializedName("totalCpuCores")
  private BigDecimal totalCpuCores = null;

  @SerializedName("avgCpuUtilization")
  private BigDecimal avgCpuUtilization = null;

  @SerializedName("maxCpuUtilization")
  private BigDecimal maxCpuUtilization = null;

  @SerializedName("avgCpuDailyPeak")
  private BigDecimal avgCpuDailyPeak = null;

  @SerializedName("avgWorkloadCpu")
  private BigDecimal avgWorkloadCpu = null;

  @SerializedName("maxWorkloadCpu")
  private BigDecimal maxWorkloadCpu = null;

  @SerializedName("avgWorkloadCpuDailyPeak")
  private BigDecimal avgWorkloadCpuDailyPeak = null;

  @SerializedName("totalMemory")
  private BigDecimal totalMemory = null;

  @SerializedName("avgMemoryUtilization")
  private BigDecimal avgMemoryUtilization = null;

  @SerializedName("maxMemoryUtilization")
  private BigDecimal maxMemoryUtilization = null;

  @SerializedName("avgMemoryDailyPeak")
  private BigDecimal avgMemoryDailyPeak = null;

  @SerializedName("avgWorkloadMemory")
  private BigDecimal avgWorkloadMemory = null;

  @SerializedName("maxWorkloadMemory")
  private BigDecimal maxWorkloadMemory = null;

  @SerializedName("avgWorkloadMemoryDailyPeak")
  private BigDecimal avgWorkloadMemoryDailyPeak = null;

  @SerializedName("tenantUtilizations")
  private ApiTenantUtilizationList tenantUtilizations = null;

  @SerializedName("maxCpuUtilizationTimestampMs")
  private BigDecimal maxCpuUtilizationTimestampMs = null;

  @SerializedName("maxMemoryUtilizationTimestampMs")
  private BigDecimal maxMemoryUtilizationTimestampMs = null;

  @SerializedName("maxWorkloadCpuTimestampMs")
  private BigDecimal maxWorkloadCpuTimestampMs = null;

  @SerializedName("maxWorkloadMemoryTimestampMs")
  private BigDecimal maxWorkloadMemoryTimestampMs = null;

  @SerializedName("errorMessage")
  private String errorMessage = null;

  public ApiClusterUtilization totalCpuCores(BigDecimal totalCpuCores) {
    this.totalCpuCores = totalCpuCores;
    return this;
  }

   /**
   * Average number of CPU cores available in the cluster during the report window.
   * @return totalCpuCores
  **/
  @ApiModelProperty(value = "Average number of CPU cores available in the cluster during the report window.")
  public BigDecimal getTotalCpuCores() {
    return totalCpuCores;
  }

  public void setTotalCpuCores(BigDecimal totalCpuCores) {
    this.totalCpuCores = totalCpuCores;
  }

  public ApiClusterUtilization avgCpuUtilization(BigDecimal avgCpuUtilization) {
    this.avgCpuUtilization = avgCpuUtilization;
    return this;
  }

   /**
   * Average CPU consumption for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return avgCpuUtilization
  **/
  @ApiModelProperty(value = "Average CPU consumption for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getAvgCpuUtilization() {
    return avgCpuUtilization;
  }

  public void setAvgCpuUtilization(BigDecimal avgCpuUtilization) {
    this.avgCpuUtilization = avgCpuUtilization;
  }

  public ApiClusterUtilization maxCpuUtilization(BigDecimal maxCpuUtilization) {
    this.maxCpuUtilization = maxCpuUtilization;
    return this;
  }

   /**
   * Maximum CPU consumption for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return maxCpuUtilization
  **/
  @ApiModelProperty(value = "Maximum CPU consumption for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getMaxCpuUtilization() {
    return maxCpuUtilization;
  }

  public void setMaxCpuUtilization(BigDecimal maxCpuUtilization) {
    this.maxCpuUtilization = maxCpuUtilization;
  }

  public ApiClusterUtilization avgCpuDailyPeak(BigDecimal avgCpuDailyPeak) {
    this.avgCpuDailyPeak = avgCpuDailyPeak;
    return this;
  }

   /**
   * Average daily peak CPU consumption for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return avgCpuDailyPeak
  **/
  @ApiModelProperty(value = "Average daily peak CPU consumption for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getAvgCpuDailyPeak() {
    return avgCpuDailyPeak;
  }

  public void setAvgCpuDailyPeak(BigDecimal avgCpuDailyPeak) {
    this.avgCpuDailyPeak = avgCpuDailyPeak;
  }

  public ApiClusterUtilization avgWorkloadCpu(BigDecimal avgWorkloadCpu) {
    this.avgWorkloadCpu = avgWorkloadCpu;
    return this;
  }

   /**
   * Average CPU consumption by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.
   * @return avgWorkloadCpu
  **/
  @ApiModelProperty(value = "Average CPU consumption by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.")
  public BigDecimal getAvgWorkloadCpu() {
    return avgWorkloadCpu;
  }

  public void setAvgWorkloadCpu(BigDecimal avgWorkloadCpu) {
    this.avgWorkloadCpu = avgWorkloadCpu;
  }

  public ApiClusterUtilization maxWorkloadCpu(BigDecimal maxWorkloadCpu) {
    this.maxWorkloadCpu = maxWorkloadCpu;
    return this;
  }

   /**
   * Maximum CPU consumption by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.
   * @return maxWorkloadCpu
  **/
  @ApiModelProperty(value = "Maximum CPU consumption by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.")
  public BigDecimal getMaxWorkloadCpu() {
    return maxWorkloadCpu;
  }

  public void setMaxWorkloadCpu(BigDecimal maxWorkloadCpu) {
    this.maxWorkloadCpu = maxWorkloadCpu;
  }

  public ApiClusterUtilization avgWorkloadCpuDailyPeak(BigDecimal avgWorkloadCpuDailyPeak) {
    this.avgWorkloadCpuDailyPeak = avgWorkloadCpuDailyPeak;
    return this;
  }

   /**
   * Average daily peak CPU consumption by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.
   * @return avgWorkloadCpuDailyPeak
  **/
  @ApiModelProperty(value = "Average daily peak CPU consumption by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.")
  public BigDecimal getAvgWorkloadCpuDailyPeak() {
    return avgWorkloadCpuDailyPeak;
  }

  public void setAvgWorkloadCpuDailyPeak(BigDecimal avgWorkloadCpuDailyPeak) {
    this.avgWorkloadCpuDailyPeak = avgWorkloadCpuDailyPeak;
  }

  public ApiClusterUtilization totalMemory(BigDecimal totalMemory) {
    this.totalMemory = totalMemory;
    return this;
  }

   /**
   * Average physical memory (in bytes) available in the cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return totalMemory
  **/
  @ApiModelProperty(value = "Average physical memory (in bytes) available in the cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getTotalMemory() {
    return totalMemory;
  }

  public void setTotalMemory(BigDecimal totalMemory) {
    this.totalMemory = totalMemory;
  }

  public ApiClusterUtilization avgMemoryUtilization(BigDecimal avgMemoryUtilization) {
    this.avgMemoryUtilization = avgMemoryUtilization;
    return this;
  }

   /**
   * Average memory consumption (as percentage of total memory) for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return avgMemoryUtilization
  **/
  @ApiModelProperty(value = "Average memory consumption (as percentage of total memory) for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getAvgMemoryUtilization() {
    return avgMemoryUtilization;
  }

  public void setAvgMemoryUtilization(BigDecimal avgMemoryUtilization) {
    this.avgMemoryUtilization = avgMemoryUtilization;
  }

  public ApiClusterUtilization maxMemoryUtilization(BigDecimal maxMemoryUtilization) {
    this.maxMemoryUtilization = maxMemoryUtilization;
    return this;
  }

   /**
   * Maximum memory consumption (as percentage of total memory) for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return maxMemoryUtilization
  **/
  @ApiModelProperty(value = "Maximum memory consumption (as percentage of total memory) for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getMaxMemoryUtilization() {
    return maxMemoryUtilization;
  }

  public void setMaxMemoryUtilization(BigDecimal maxMemoryUtilization) {
    this.maxMemoryUtilization = maxMemoryUtilization;
  }

  public ApiClusterUtilization avgMemoryDailyPeak(BigDecimal avgMemoryDailyPeak) {
    this.avgMemoryDailyPeak = avgMemoryDailyPeak;
    return this;
  }

   /**
   * Average daily peak memory consumption (as percentage of total memory) for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.
   * @return avgMemoryDailyPeak
  **/
  @ApiModelProperty(value = "Average daily peak memory consumption (as percentage of total memory) for the entire cluster during the report window. This includes consumption by user workloads in YARN and Impala, as well as consumption by all services running in the cluster.")
  public BigDecimal getAvgMemoryDailyPeak() {
    return avgMemoryDailyPeak;
  }

  public void setAvgMemoryDailyPeak(BigDecimal avgMemoryDailyPeak) {
    this.avgMemoryDailyPeak = avgMemoryDailyPeak;
  }

  public ApiClusterUtilization avgWorkloadMemory(BigDecimal avgWorkloadMemory) {
    this.avgWorkloadMemory = avgWorkloadMemory;
    return this;
  }

   /**
   * Average memory consumption (as percentage of total memory) by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.
   * @return avgWorkloadMemory
  **/
  @ApiModelProperty(value = "Average memory consumption (as percentage of total memory) by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.")
  public BigDecimal getAvgWorkloadMemory() {
    return avgWorkloadMemory;
  }

  public void setAvgWorkloadMemory(BigDecimal avgWorkloadMemory) {
    this.avgWorkloadMemory = avgWorkloadMemory;
  }

  public ApiClusterUtilization maxWorkloadMemory(BigDecimal maxWorkloadMemory) {
    this.maxWorkloadMemory = maxWorkloadMemory;
    return this;
  }

   /**
   * Maximum memory consumption (as percentage of total memory) by workloads that ran on the cluster. This includes consumption by user workloads in YARN and Impala
   * @return maxWorkloadMemory
  **/
  @ApiModelProperty(value = "Maximum memory consumption (as percentage of total memory) by workloads that ran on the cluster. This includes consumption by user workloads in YARN and Impala")
  public BigDecimal getMaxWorkloadMemory() {
    return maxWorkloadMemory;
  }

  public void setMaxWorkloadMemory(BigDecimal maxWorkloadMemory) {
    this.maxWorkloadMemory = maxWorkloadMemory;
  }

  public ApiClusterUtilization avgWorkloadMemoryDailyPeak(BigDecimal avgWorkloadMemoryDailyPeak) {
    this.avgWorkloadMemoryDailyPeak = avgWorkloadMemoryDailyPeak;
    return this;
  }

   /**
   * Average daily peak memory consumption (as percentage of total memory) by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.
   * @return avgWorkloadMemoryDailyPeak
  **/
  @ApiModelProperty(value = "Average daily peak memory consumption (as percentage of total memory) by workloads that ran on the cluster during the report window. This includes consumption by user workloads in YARN and Impala.")
  public BigDecimal getAvgWorkloadMemoryDailyPeak() {
    return avgWorkloadMemoryDailyPeak;
  }

  public void setAvgWorkloadMemoryDailyPeak(BigDecimal avgWorkloadMemoryDailyPeak) {
    this.avgWorkloadMemoryDailyPeak = avgWorkloadMemoryDailyPeak;
  }

  public ApiClusterUtilization tenantUtilizations(ApiTenantUtilizationList tenantUtilizations) {
    this.tenantUtilizations = tenantUtilizations;
    return this;
  }

   /**
   * A list of tenant utilization reports.
   * @return tenantUtilizations
  **/
  @ApiModelProperty(value = "A list of tenant utilization reports.")
  public ApiTenantUtilizationList getTenantUtilizations() {
    return tenantUtilizations;
  }

  public void setTenantUtilizations(ApiTenantUtilizationList tenantUtilizations) {
    this.tenantUtilizations = tenantUtilizations;
  }

  public ApiClusterUtilization maxCpuUtilizationTimestampMs(BigDecimal maxCpuUtilizationTimestampMs) {
    this.maxCpuUtilizationTimestampMs = maxCpuUtilizationTimestampMs;
    return this;
  }

   /**
   * Timestamp corresponding to maximum CPU utilization for the entire cluster during the report window.
   * @return maxCpuUtilizationTimestampMs
  **/
  @ApiModelProperty(value = "Timestamp corresponding to maximum CPU utilization for the entire cluster during the report window.")
  public BigDecimal getMaxCpuUtilizationTimestampMs() {
    return maxCpuUtilizationTimestampMs;
  }

  public void setMaxCpuUtilizationTimestampMs(BigDecimal maxCpuUtilizationTimestampMs) {
    this.maxCpuUtilizationTimestampMs = maxCpuUtilizationTimestampMs;
  }

  public ApiClusterUtilization maxMemoryUtilizationTimestampMs(BigDecimal maxMemoryUtilizationTimestampMs) {
    this.maxMemoryUtilizationTimestampMs = maxMemoryUtilizationTimestampMs;
    return this;
  }

   /**
   * Timestamp corresponding to maximum memory utilization for the entire cluster during the report window.
   * @return maxMemoryUtilizationTimestampMs
  **/
  @ApiModelProperty(value = "Timestamp corresponding to maximum memory utilization for the entire cluster during the report window.")
  public BigDecimal getMaxMemoryUtilizationTimestampMs() {
    return maxMemoryUtilizationTimestampMs;
  }

  public void setMaxMemoryUtilizationTimestampMs(BigDecimal maxMemoryUtilizationTimestampMs) {
    this.maxMemoryUtilizationTimestampMs = maxMemoryUtilizationTimestampMs;
  }

  public ApiClusterUtilization maxWorkloadCpuTimestampMs(BigDecimal maxWorkloadCpuTimestampMs) {
    this.maxWorkloadCpuTimestampMs = maxWorkloadCpuTimestampMs;
    return this;
  }

   /**
   * Timestamp corresponds to maximum CPU consumption by workloads that ran on the cluster during the report window.
   * @return maxWorkloadCpuTimestampMs
  **/
  @ApiModelProperty(value = "Timestamp corresponds to maximum CPU consumption by workloads that ran on the cluster during the report window.")
  public BigDecimal getMaxWorkloadCpuTimestampMs() {
    return maxWorkloadCpuTimestampMs;
  }

  public void setMaxWorkloadCpuTimestampMs(BigDecimal maxWorkloadCpuTimestampMs) {
    this.maxWorkloadCpuTimestampMs = maxWorkloadCpuTimestampMs;
  }

  public ApiClusterUtilization maxWorkloadMemoryTimestampMs(BigDecimal maxWorkloadMemoryTimestampMs) {
    this.maxWorkloadMemoryTimestampMs = maxWorkloadMemoryTimestampMs;
    return this;
  }

   /**
   * Timestamp corresponds to maximum memory resource consumption by workloads that ran on the cluster during the report window.
   * @return maxWorkloadMemoryTimestampMs
  **/
  @ApiModelProperty(value = "Timestamp corresponds to maximum memory resource consumption by workloads that ran on the cluster during the report window.")
  public BigDecimal getMaxWorkloadMemoryTimestampMs() {
    return maxWorkloadMemoryTimestampMs;
  }

  public void setMaxWorkloadMemoryTimestampMs(BigDecimal maxWorkloadMemoryTimestampMs) {
    this.maxWorkloadMemoryTimestampMs = maxWorkloadMemoryTimestampMs;
  }

  public ApiClusterUtilization errorMessage(String errorMessage) {
    this.errorMessage = errorMessage;
    return this;
  }

   /**
   * Error message while generating utilization report.
   * @return errorMessage
  **/
  @ApiModelProperty(value = "Error message while generating utilization report.")
  public String getErrorMessage() {
    return errorMessage;
  }

  public void setErrorMessage(String errorMessage) {
    this.errorMessage = errorMessage;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiClusterUtilization apiClusterUtilization = (ApiClusterUtilization) o;
    return Objects.equals(this.totalCpuCores, apiClusterUtilization.totalCpuCores) &&
        Objects.equals(this.avgCpuUtilization, apiClusterUtilization.avgCpuUtilization) &&
        Objects.equals(this.maxCpuUtilization, apiClusterUtilization.maxCpuUtilization) &&
        Objects.equals(this.avgCpuDailyPeak, apiClusterUtilization.avgCpuDailyPeak) &&
        Objects.equals(this.avgWorkloadCpu, apiClusterUtilization.avgWorkloadCpu) &&
        Objects.equals(this.maxWorkloadCpu, apiClusterUtilization.maxWorkloadCpu) &&
        Objects.equals(this.avgWorkloadCpuDailyPeak, apiClusterUtilization.avgWorkloadCpuDailyPeak) &&
        Objects.equals(this.totalMemory, apiClusterUtilization.totalMemory) &&
        Objects.equals(this.avgMemoryUtilization, apiClusterUtilization.avgMemoryUtilization) &&
        Objects.equals(this.maxMemoryUtilization, apiClusterUtilization.maxMemoryUtilization) &&
        Objects.equals(this.avgMemoryDailyPeak, apiClusterUtilization.avgMemoryDailyPeak) &&
        Objects.equals(this.avgWorkloadMemory, apiClusterUtilization.avgWorkloadMemory) &&
        Objects.equals(this.maxWorkloadMemory, apiClusterUtilization.maxWorkloadMemory) &&
        Objects.equals(this.avgWorkloadMemoryDailyPeak, apiClusterUtilization.avgWorkloadMemoryDailyPeak) &&
        Objects.equals(this.tenantUtilizations, apiClusterUtilization.tenantUtilizations) &&
        Objects.equals(this.maxCpuUtilizationTimestampMs, apiClusterUtilization.maxCpuUtilizationTimestampMs) &&
        Objects.equals(this.maxMemoryUtilizationTimestampMs, apiClusterUtilization.maxMemoryUtilizationTimestampMs) &&
        Objects.equals(this.maxWorkloadCpuTimestampMs, apiClusterUtilization.maxWorkloadCpuTimestampMs) &&
        Objects.equals(this.maxWorkloadMemoryTimestampMs, apiClusterUtilization.maxWorkloadMemoryTimestampMs) &&
        Objects.equals(this.errorMessage, apiClusterUtilization.errorMessage);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalCpuCores, avgCpuUtilization, maxCpuUtilization, avgCpuDailyPeak, avgWorkloadCpu, maxWorkloadCpu, avgWorkloadCpuDailyPeak, totalMemory, avgMemoryUtilization, maxMemoryUtilization, avgMemoryDailyPeak, avgWorkloadMemory, maxWorkloadMemory, avgWorkloadMemoryDailyPeak, tenantUtilizations, maxCpuUtilizationTimestampMs, maxMemoryUtilizationTimestampMs, maxWorkloadCpuTimestampMs, maxWorkloadMemoryTimestampMs, errorMessage);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiClusterUtilization {\n");
    
    sb.append("    totalCpuCores: ").append(toIndentedString(totalCpuCores)).append("\n");
    sb.append("    avgCpuUtilization: ").append(toIndentedString(avgCpuUtilization)).append("\n");
    sb.append("    maxCpuUtilization: ").append(toIndentedString(maxCpuUtilization)).append("\n");
    sb.append("    avgCpuDailyPeak: ").append(toIndentedString(avgCpuDailyPeak)).append("\n");
    sb.append("    avgWorkloadCpu: ").append(toIndentedString(avgWorkloadCpu)).append("\n");
    sb.append("    maxWorkloadCpu: ").append(toIndentedString(maxWorkloadCpu)).append("\n");
    sb.append("    avgWorkloadCpuDailyPeak: ").append(toIndentedString(avgWorkloadCpuDailyPeak)).append("\n");
    sb.append("    totalMemory: ").append(toIndentedString(totalMemory)).append("\n");
    sb.append("    avgMemoryUtilization: ").append(toIndentedString(avgMemoryUtilization)).append("\n");
    sb.append("    maxMemoryUtilization: ").append(toIndentedString(maxMemoryUtilization)).append("\n");
    sb.append("    avgMemoryDailyPeak: ").append(toIndentedString(avgMemoryDailyPeak)).append("\n");
    sb.append("    avgWorkloadMemory: ").append(toIndentedString(avgWorkloadMemory)).append("\n");
    sb.append("    maxWorkloadMemory: ").append(toIndentedString(maxWorkloadMemory)).append("\n");
    sb.append("    avgWorkloadMemoryDailyPeak: ").append(toIndentedString(avgWorkloadMemoryDailyPeak)).append("\n");
    sb.append("    tenantUtilizations: ").append(toIndentedString(tenantUtilizations)).append("\n");
    sb.append("    maxCpuUtilizationTimestampMs: ").append(toIndentedString(maxCpuUtilizationTimestampMs)).append("\n");
    sb.append("    maxMemoryUtilizationTimestampMs: ").append(toIndentedString(maxMemoryUtilizationTimestampMs)).append("\n");
    sb.append("    maxWorkloadCpuTimestampMs: ").append(toIndentedString(maxWorkloadCpuTimestampMs)).append("\n");
    sb.append("    maxWorkloadMemoryTimestampMs: ").append(toIndentedString(maxWorkloadMemoryTimestampMs)).append("\n");
    sb.append("    errorMessage: ").append(toIndentedString(errorMessage)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

