/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiHealthSummary;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Represents a result from a health test performed by Cloudera Manager for an entity.
 */
@ApiModel(description = "Represents a result from a health test performed by Cloudera Manager for an entity.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-09-25T07:41:36.316Z")
public class ApiHealthCheck {
  @SerializedName("name")
  private String name = null;

  @SerializedName("summary")
  private ApiHealthSummary summary = null;

  @SerializedName("explanation")
  private String explanation = null;

  @SerializedName("suppressed")
  private Boolean suppressed = null;

  public ApiHealthCheck name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Unique name of this health check.
   * @return name
  **/
  @ApiModelProperty(value = "Unique name of this health check.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApiHealthCheck summary(ApiHealthSummary summary) {
    this.summary = summary;
    return this;
  }

   /**
   * The summary status of this check.
   * @return summary
  **/
  @ApiModelProperty(value = "The summary status of this check.")
  public ApiHealthSummary getSummary() {
    return summary;
  }

  public void setSummary(ApiHealthSummary summary) {
    this.summary = summary;
  }

  public ApiHealthCheck explanation(String explanation) {
    this.explanation = explanation;
    return this;
  }

   /**
   * The explanation of this health check. Available since v11.
   * @return explanation
  **/
  @ApiModelProperty(value = "The explanation of this health check. Available since v11.")
  public String getExplanation() {
    return explanation;
  }

  public void setExplanation(String explanation) {
    this.explanation = explanation;
  }

  public ApiHealthCheck suppressed(Boolean suppressed) {
    this.suppressed = suppressed;
    return this;
  }

   /**
   * Whether this health test is suppressed. A suppressed health test is not considered when computing an entity&#39;s overall health. Available since v11.
   * @return suppressed
  **/
  @ApiModelProperty(value = "Whether this health test is suppressed. A suppressed health test is not considered when computing an entity's overall health. Available since v11.")
  public Boolean getSuppressed() {
    return suppressed;
  }

  public void setSuppressed(Boolean suppressed) {
    this.suppressed = suppressed;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiHealthCheck apiHealthCheck = (ApiHealthCheck) o;
    return Objects.equals(this.name, apiHealthCheck.name) &&
        Objects.equals(this.summary, apiHealthCheck.summary) &&
        Objects.equals(this.explanation, apiHealthCheck.explanation) &&
        Objects.equals(this.suppressed, apiHealthCheck.suppressed);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, summary, explanation, suppressed);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiHealthCheck {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    summary: ").append(toIndentedString(summary)).append("\n");
    sb.append("    explanation: ").append(toIndentedString(explanation)).append("\n");
    sb.append("    suppressed: ").append(toIndentedString(suppressed)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

