/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiHostNameList;
import com.cloudera.api.swagger.model.ApiPerfInspectorPingArgs;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Arguments used for the Cloudera Manager level performance inspector. Network diagnostics will be run from every host in sourceHostList to every host in targetHostList.
 */
@ApiModel(description = "Arguments used for the Cloudera Manager level performance inspector. Network diagnostics will be run from every host in sourceHostList to every host in targetHostList.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-09-25T07:41:36.316Z")
public class ApiHostsPerfInspectorArgs {
  @SerializedName("sourceHostList")
  private ApiHostNameList sourceHostList = null;

  @SerializedName("targetHostList")
  private ApiHostNameList targetHostList = null;

  @SerializedName("pingArgs")
  private ApiPerfInspectorPingArgs pingArgs = null;

  public ApiHostsPerfInspectorArgs sourceHostList(ApiHostNameList sourceHostList) {
    this.sourceHostList = sourceHostList;
    return this;
  }

   /**
   * Required list of host names which&#39;ll act as source for running network diagnostics test.
   * @return sourceHostList
  **/
  @ApiModelProperty(value = "Required list of host names which'll act as source for running network diagnostics test.")
  public ApiHostNameList getSourceHostList() {
    return sourceHostList;
  }

  public void setSourceHostList(ApiHostNameList sourceHostList) {
    this.sourceHostList = sourceHostList;
  }

  public ApiHostsPerfInspectorArgs targetHostList(ApiHostNameList targetHostList) {
    this.targetHostList = targetHostList;
    return this;
  }

   /**
   * Required list of host names which&#39;ll act as target for running network diagnostics test.
   * @return targetHostList
  **/
  @ApiModelProperty(value = "Required list of host names which'll act as target for running network diagnostics test.")
  public ApiHostNameList getTargetHostList() {
    return targetHostList;
  }

  public void setTargetHostList(ApiHostNameList targetHostList) {
    this.targetHostList = targetHostList;
  }

  public ApiHostsPerfInspectorArgs pingArgs(ApiPerfInspectorPingArgs pingArgs) {
    this.pingArgs = pingArgs;
    return this;
  }

   /**
   * Optional ping request arguments. If not specified, default arguments will be used for ping test.
   * @return pingArgs
  **/
  @ApiModelProperty(value = "Optional ping request arguments. If not specified, default arguments will be used for ping test.")
  public ApiPerfInspectorPingArgs getPingArgs() {
    return pingArgs;
  }

  public void setPingArgs(ApiPerfInspectorPingArgs pingArgs) {
    this.pingArgs = pingArgs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiHostsPerfInspectorArgs apiHostsPerfInspectorArgs = (ApiHostsPerfInspectorArgs) o;
    return Objects.equals(this.sourceHostList, apiHostsPerfInspectorArgs.sourceHostList) &&
        Objects.equals(this.targetHostList, apiHostsPerfInspectorArgs.targetHostList) &&
        Objects.equals(this.pingArgs, apiHostsPerfInspectorArgs.pingArgs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sourceHostList, targetHostList, pingArgs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiHostsPerfInspectorArgs {\n");
    
    sb.append("    sourceHostList: ").append(toIndentedString(sourceHostList)).append("\n");
    sb.append("    targetHostList: ").append(toIndentedString(targetHostList)).append("\n");
    sb.append("    pingArgs: ").append(toIndentedString(pingArgs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

