/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Metadata about an Impala query attribute.
 */
@ApiModel(description = "Metadata about an Impala query attribute.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-09-25T07:41:36.316Z")
public class ApiImpalaQueryAttribute {
  @SerializedName("name")
  private String name = null;

  @SerializedName("type")
  private String type = null;

  @SerializedName("displayName")
  private String displayName = null;

  @SerializedName("supportsHistograms")
  private Boolean supportsHistograms = null;

  @SerializedName("description")
  private String description = null;

  public ApiImpalaQueryAttribute name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the attribute. This name can be used in filters, for example &#39;user&#39; could be used in the filter &#39;user &#x3D; root&#39;.
   * @return name
  **/
  @ApiModelProperty(value = "The name of the attribute. This name can be used in filters, for example 'user' could be used in the filter 'user = root'.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApiImpalaQueryAttribute type(String type) {
    this.type = type;
    return this;
  }

   /**
   * The type of the attribute. Valid types are STRING, NUMBER, BOOLEAN, BYTES, MILLISECONDS, BYTES_PER_SECOND, BYTE_SECONDS.
   * @return type
  **/
  @ApiModelProperty(value = "The type of the attribute. Valid types are STRING, NUMBER, BOOLEAN, BYTES, MILLISECONDS, BYTES_PER_SECOND, BYTE_SECONDS.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public ApiImpalaQueryAttribute displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * The display name for the attribute.
   * @return displayName
  **/
  @ApiModelProperty(value = "The display name for the attribute.")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public ApiImpalaQueryAttribute supportsHistograms(Boolean supportsHistograms) {
    this.supportsHistograms = supportsHistograms;
    return this;
  }

   /**
   * Whether the Service Monitor can generate a histogram of the distribution of the attribute across queries.
   * @return supportsHistograms
  **/
  @ApiModelProperty(value = "Whether the Service Monitor can generate a histogram of the distribution of the attribute across queries.")
  public Boolean getSupportsHistograms() {
    return supportsHistograms;
  }

  public void setSupportsHistograms(Boolean supportsHistograms) {
    this.supportsHistograms = supportsHistograms;
  }

  public ApiImpalaQueryAttribute description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The description of the attribute.
   * @return description
  **/
  @ApiModelProperty(value = "The description of the attribute.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiImpalaQueryAttribute apiImpalaQueryAttribute = (ApiImpalaQueryAttribute) o;
    return Objects.equals(this.name, apiImpalaQueryAttribute.name) &&
        Objects.equals(this.type, apiImpalaQueryAttribute.type) &&
        Objects.equals(this.displayName, apiImpalaQueryAttribute.displayName) &&
        Objects.equals(this.supportsHistograms, apiImpalaQueryAttribute.supportsHistograms) &&
        Objects.equals(this.description, apiImpalaQueryAttribute.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, displayName, supportsHistograms, description);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiImpalaQueryAttribute {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    supportsHistograms: ").append(toIndentedString(supportsHistograms)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

