/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiCommissionState;
import com.cloudera.api.swagger.model.ApiConfigList;
import com.cloudera.api.swagger.model.ApiConfigStalenessStatus;
import com.cloudera.api.swagger.model.ApiEntityStatus;
import com.cloudera.api.swagger.model.ApiEntityType;
import com.cloudera.api.swagger.model.ApiHealthCheck;
import com.cloudera.api.swagger.model.ApiHealthSummary;
import com.cloudera.api.swagger.model.ApiHostRef;
import com.cloudera.api.swagger.model.ApiRoleConfigGroupRef;
import com.cloudera.api.swagger.model.ApiRoleState;
import com.cloudera.api.swagger.model.ApiServiceRef;
import com.cloudera.api.swagger.model.HaStatus;
import com.cloudera.api.swagger.model.ZooKeeperServerMode;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * A role represents a specific entity that participate in a service. Examples are JobTrackers, DataNodes, HBase Masters. Each role is assigned a host where it runs on.
 */
@ApiModel(description = "A role represents a specific entity that participate in a service. Examples are JobTrackers, DataNodes, HBase Masters. Each role is assigned a host where it runs on.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-09-25T07:41:36.316Z")
public class ApiRole {
  @SerializedName("name")
  private String name = null;

  @SerializedName("type")
  private String type = null;

  @SerializedName("hostRef")
  private ApiHostRef hostRef = null;

  @SerializedName("serviceRef")
  private ApiServiceRef serviceRef = null;

  @SerializedName("roleState")
  private ApiRoleState roleState = null;

  @SerializedName("commissionState")
  private ApiCommissionState commissionState = null;

  @SerializedName("healthSummary")
  private ApiHealthSummary healthSummary = null;

  @SerializedName("configStale")
  private Boolean configStale = null;

  @SerializedName("configStalenessStatus")
  private ApiConfigStalenessStatus configStalenessStatus = null;

  @SerializedName("healthChecks")
  private List<ApiHealthCheck> healthChecks = null;

  @SerializedName("haStatus")
  private HaStatus haStatus = null;

  @SerializedName("roleUrl")
  private String roleUrl = null;

  @SerializedName("maintenanceMode")
  private Boolean maintenanceMode = null;

  @SerializedName("maintenanceOwners")
  private List<ApiEntityType> maintenanceOwners = null;

  @SerializedName("config")
  private ApiConfigList config = null;

  @SerializedName("roleConfigGroupRef")
  private ApiRoleConfigGroupRef roleConfigGroupRef = null;

  @SerializedName("zooKeeperServerMode")
  private ZooKeeperServerMode zooKeeperServerMode = null;

  @SerializedName("entityStatus")
  private ApiEntityStatus entityStatus = null;

  public ApiRole name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the role. Optional when creating a role since API v6. If not specified, a name will be automatically generated for the role.
   * @return name
  **/
  @ApiModelProperty(value = "The name of the role. Optional when creating a role since API v6. If not specified, a name will be automatically generated for the role.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApiRole type(String type) {
    this.type = type;
    return this;
  }

   /**
   * The type of the role, e.g. NAMENODE, DATANODE, TASKTRACKER.
   * @return type
  **/
  @ApiModelProperty(value = "The type of the role, e.g. NAMENODE, DATANODE, TASKTRACKER.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public ApiRole hostRef(ApiHostRef hostRef) {
    this.hostRef = hostRef;
    return this;
  }

   /**
   * A reference to the host where this role runs.
   * @return hostRef
  **/
  @ApiModelProperty(value = "A reference to the host where this role runs.")
  public ApiHostRef getHostRef() {
    return hostRef;
  }

  public void setHostRef(ApiHostRef hostRef) {
    this.hostRef = hostRef;
  }

  public ApiRole serviceRef(ApiServiceRef serviceRef) {
    this.serviceRef = serviceRef;
    return this;
  }

   /**
   * Readonly. A reference to the parent service.
   * @return serviceRef
  **/
  @ApiModelProperty(value = "Readonly. A reference to the parent service.")
  public ApiServiceRef getServiceRef() {
    return serviceRef;
  }

  public void setServiceRef(ApiServiceRef serviceRef) {
    this.serviceRef = serviceRef;
  }

  public ApiRole roleState(ApiRoleState roleState) {
    this.roleState = roleState;
    return this;
  }

   /**
   * Readonly. The configured run state of this role. Whether it&#39;s running, etc.
   * @return roleState
  **/
  @ApiModelProperty(value = "Readonly. The configured run state of this role. Whether it's running, etc.")
  public ApiRoleState getRoleState() {
    return roleState;
  }

  public void setRoleState(ApiRoleState roleState) {
    this.roleState = roleState;
  }

  public ApiRole commissionState(ApiCommissionState commissionState) {
    this.commissionState = commissionState;
    return this;
  }

   /**
   * Readonly. The commission state of this role. Available since API v2.
   * @return commissionState
  **/
  @ApiModelProperty(value = "Readonly. The commission state of this role. Available since API v2.")
  public ApiCommissionState getCommissionState() {
    return commissionState;
  }

  public void setCommissionState(ApiCommissionState commissionState) {
    this.commissionState = commissionState;
  }

  public ApiRole healthSummary(ApiHealthSummary healthSummary) {
    this.healthSummary = healthSummary;
    return this;
  }

   /**
   * Readonly. The high-level health status of this role.
   * @return healthSummary
  **/
  @ApiModelProperty(value = "Readonly. The high-level health status of this role.")
  public ApiHealthSummary getHealthSummary() {
    return healthSummary;
  }

  public void setHealthSummary(ApiHealthSummary healthSummary) {
    this.healthSummary = healthSummary;
  }

  public ApiRole configStale(Boolean configStale) {
    this.configStale = configStale;
    return this;
  }

   /**
   * Readonly. Expresses whether the role configuration is stale.
   * @return configStale
  **/
  @ApiModelProperty(value = "Readonly. Expresses whether the role configuration is stale.")
  public Boolean getConfigStale() {
    return configStale;
  }

  public void setConfigStale(Boolean configStale) {
    this.configStale = configStale;
  }

  public ApiRole configStalenessStatus(ApiConfigStalenessStatus configStalenessStatus) {
    this.configStalenessStatus = configStalenessStatus;
    return this;
  }

   /**
   * Readonly. Expresses the role&#39;s configuration staleness status. Available since API v6.
   * @return configStalenessStatus
  **/
  @ApiModelProperty(value = "Readonly. Expresses the role's configuration staleness status. Available since API v6.")
  public ApiConfigStalenessStatus getConfigStalenessStatus() {
    return configStalenessStatus;
  }

  public void setConfigStalenessStatus(ApiConfigStalenessStatus configStalenessStatus) {
    this.configStalenessStatus = configStalenessStatus;
  }

  public ApiRole healthChecks(List<ApiHealthCheck> healthChecks) {
    this.healthChecks = healthChecks;
    return this;
  }

  public ApiRole addHealthChecksItem(ApiHealthCheck healthChecksItem) {
    if (this.healthChecks == null) {
      this.healthChecks = new ArrayList<ApiHealthCheck>();
    }
    this.healthChecks.add(healthChecksItem);
    return this;
  }

   /**
   * Readonly. The list of health checks of this service.
   * @return healthChecks
  **/
  @ApiModelProperty(value = "Readonly. The list of health checks of this service.")
  public List<ApiHealthCheck> getHealthChecks() {
    return healthChecks;
  }

  public void setHealthChecks(List<ApiHealthCheck> healthChecks) {
    this.healthChecks = healthChecks;
  }

  public ApiRole haStatus(HaStatus haStatus) {
    this.haStatus = haStatus;
    return this;
  }

   /**
   * Readonly. The HA status of this role.
   * @return haStatus
  **/
  @ApiModelProperty(value = "Readonly. The HA status of this role.")
  public HaStatus getHaStatus() {
    return haStatus;
  }

  public void setHaStatus(HaStatus haStatus) {
    this.haStatus = haStatus;
  }

  public ApiRole roleUrl(String roleUrl) {
    this.roleUrl = roleUrl;
    return this;
  }

   /**
   * Readonly. Link into the Cloudera Manager web UI for this specific role.
   * @return roleUrl
  **/
  @ApiModelProperty(value = "Readonly. Link into the Cloudera Manager web UI for this specific role.")
  public String getRoleUrl() {
    return roleUrl;
  }

  public void setRoleUrl(String roleUrl) {
    this.roleUrl = roleUrl;
  }

  public ApiRole maintenanceMode(Boolean maintenanceMode) {
    this.maintenanceMode = maintenanceMode;
    return this;
  }

   /**
   * Readonly. Whether the role is in maintenance mode. Available since API v2.
   * @return maintenanceMode
  **/
  @ApiModelProperty(value = "Readonly. Whether the role is in maintenance mode. Available since API v2.")
  public Boolean getMaintenanceMode() {
    return maintenanceMode;
  }

  public void setMaintenanceMode(Boolean maintenanceMode) {
    this.maintenanceMode = maintenanceMode;
  }

  public ApiRole maintenanceOwners(List<ApiEntityType> maintenanceOwners) {
    this.maintenanceOwners = maintenanceOwners;
    return this;
  }

  public ApiRole addMaintenanceOwnersItem(ApiEntityType maintenanceOwnersItem) {
    if (this.maintenanceOwners == null) {
      this.maintenanceOwners = new ArrayList<ApiEntityType>();
    }
    this.maintenanceOwners.add(maintenanceOwnersItem);
    return this;
  }

   /**
   * Readonly. The list of objects that trigger this role to be in maintenance mode. Available since API v2.
   * @return maintenanceOwners
  **/
  @ApiModelProperty(example = "\"null\"", value = "Readonly. The list of objects that trigger this role to be in maintenance mode. Available since API v2.")
  public List<ApiEntityType> getMaintenanceOwners() {
    return maintenanceOwners;
  }

  public void setMaintenanceOwners(List<ApiEntityType> maintenanceOwners) {
    this.maintenanceOwners = maintenanceOwners;
  }

  public ApiRole config(ApiConfigList config) {
    this.config = config;
    return this;
  }

   /**
   * The role configuration. Optional.
   * @return config
  **/
  @ApiModelProperty(value = "The role configuration. Optional.")
  public ApiConfigList getConfig() {
    return config;
  }

  public void setConfig(ApiConfigList config) {
    this.config = config;
  }

  public ApiRole roleConfigGroupRef(ApiRoleConfigGroupRef roleConfigGroupRef) {
    this.roleConfigGroupRef = roleConfigGroupRef;
    return this;
  }

   /**
   * Readonly. The reference to the role configuration group of this role. Available since API v3.
   * @return roleConfigGroupRef
  **/
  @ApiModelProperty(value = "Readonly. The reference to the role configuration group of this role. Available since API v3.")
  public ApiRoleConfigGroupRef getRoleConfigGroupRef() {
    return roleConfigGroupRef;
  }

  public void setRoleConfigGroupRef(ApiRoleConfigGroupRef roleConfigGroupRef) {
    this.roleConfigGroupRef = roleConfigGroupRef;
  }

  public ApiRole zooKeeperServerMode(ZooKeeperServerMode zooKeeperServerMode) {
    this.zooKeeperServerMode = zooKeeperServerMode;
    return this;
  }

   /**
   * Readonly. The ZooKeeper server mode for this role. Note that for non-ZooKeeper Server roles this will be null. Available since API v6.
   * @return zooKeeperServerMode
  **/
  @ApiModelProperty(value = "Readonly. The ZooKeeper server mode for this role. Note that for non-ZooKeeper Server roles this will be null. Available since API v6.")
  public ZooKeeperServerMode getZooKeeperServerMode() {
    return zooKeeperServerMode;
  }

  public void setZooKeeperServerMode(ZooKeeperServerMode zooKeeperServerMode) {
    this.zooKeeperServerMode = zooKeeperServerMode;
  }

  public ApiRole entityStatus(ApiEntityStatus entityStatus) {
    this.entityStatus = entityStatus;
    return this;
  }

   /**
   * Readonly. The entity status for this role. Available since API v11.
   * @return entityStatus
  **/
  @ApiModelProperty(value = "Readonly. The entity status for this role. Available since API v11.")
  public ApiEntityStatus getEntityStatus() {
    return entityStatus;
  }

  public void setEntityStatus(ApiEntityStatus entityStatus) {
    this.entityStatus = entityStatus;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiRole apiRole = (ApiRole) o;
    return Objects.equals(this.name, apiRole.name) &&
        Objects.equals(this.type, apiRole.type) &&
        Objects.equals(this.hostRef, apiRole.hostRef) &&
        Objects.equals(this.serviceRef, apiRole.serviceRef) &&
        Objects.equals(this.roleState, apiRole.roleState) &&
        Objects.equals(this.commissionState, apiRole.commissionState) &&
        Objects.equals(this.healthSummary, apiRole.healthSummary) &&
        Objects.equals(this.configStale, apiRole.configStale) &&
        Objects.equals(this.configStalenessStatus, apiRole.configStalenessStatus) &&
        Objects.equals(this.healthChecks, apiRole.healthChecks) &&
        Objects.equals(this.haStatus, apiRole.haStatus) &&
        Objects.equals(this.roleUrl, apiRole.roleUrl) &&
        Objects.equals(this.maintenanceMode, apiRole.maintenanceMode) &&
        Objects.equals(this.maintenanceOwners, apiRole.maintenanceOwners) &&
        Objects.equals(this.config, apiRole.config) &&
        Objects.equals(this.roleConfigGroupRef, apiRole.roleConfigGroupRef) &&
        Objects.equals(this.zooKeeperServerMode, apiRole.zooKeeperServerMode) &&
        Objects.equals(this.entityStatus, apiRole.entityStatus);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, hostRef, serviceRef, roleState, commissionState, healthSummary, configStale, configStalenessStatus, healthChecks, haStatus, roleUrl, maintenanceMode, maintenanceOwners, config, roleConfigGroupRef, zooKeeperServerMode, entityStatus);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiRole {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    hostRef: ").append(toIndentedString(hostRef)).append("\n");
    sb.append("    serviceRef: ").append(toIndentedString(serviceRef)).append("\n");
    sb.append("    roleState: ").append(toIndentedString(roleState)).append("\n");
    sb.append("    commissionState: ").append(toIndentedString(commissionState)).append("\n");
    sb.append("    healthSummary: ").append(toIndentedString(healthSummary)).append("\n");
    sb.append("    configStale: ").append(toIndentedString(configStale)).append("\n");
    sb.append("    configStalenessStatus: ").append(toIndentedString(configStalenessStatus)).append("\n");
    sb.append("    healthChecks: ").append(toIndentedString(healthChecks)).append("\n");
    sb.append("    haStatus: ").append(toIndentedString(haStatus)).append("\n");
    sb.append("    roleUrl: ").append(toIndentedString(roleUrl)).append("\n");
    sb.append("    maintenanceMode: ").append(toIndentedString(maintenanceMode)).append("\n");
    sb.append("    maintenanceOwners: ").append(toIndentedString(maintenanceOwners)).append("\n");
    sb.append("    config: ").append(toIndentedString(config)).append("\n");
    sb.append("    roleConfigGroupRef: ").append(toIndentedString(roleConfigGroupRef)).append("\n");
    sb.append("    zooKeeperServerMode: ").append(toIndentedString(zooKeeperServerMode)).append("\n");
    sb.append("    entityStatus: ").append(toIndentedString(entityStatus)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

