/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiActivity;
import com.cloudera.api.swagger.model.ApiActivityList;
import com.cloudera.api.swagger.model.ApiMetricList;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ActivitiesResourceApi
 */
@Ignore
public class ActivitiesResourceApiTest {

    private final ActivitiesResourceApi api = new ActivitiesResourceApi();

    
    /**
     * Fetch metric readings for a particular activity.
     *
     * Fetch metric readings for a particular activity. &lt;p&gt; By default, this call will look up all metrics available for the activity. If only specific metrics are desired, use the &lt;i&gt;metrics&lt;/i&gt; parameter. &lt;p&gt; By default, the returned results correspond to a 5 minute window based on the provided end time (which defaults to the current server time). The &lt;i&gt;from&lt;/i&gt; and &lt;i&gt;to&lt;/i&gt; parameters can be used to control the window being queried. A maximum window of 3 hours is enforced. &lt;p&gt; When requesting a \&quot;full\&quot; view, aside from the extended properties of the returned metric data, the collection will also contain information about all metrics available for the activity, even if no readings are available in the requested window.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getMetricsTest() throws ApiException {
        String activityId = null;
        String clusterName = null;
        String serviceName = null;
        String from = null;
        List<String> metrics = null;
        String to = null;
        String view = null;
        ApiMetricList response = api.getMetrics(activityId, clusterName, serviceName, from, metrics, to, view);

        // TODO: test validations
    }
    
    /**
     * Read all activities in the system.
     *
     * Read all activities in the system
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readActivitiesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        Integer maxResults = null;
        String query = null;
        Integer resultOffset = null;
        String view = null;
        ApiActivityList response = api.readActivities(clusterName, serviceName, maxResults, query, resultOffset, view);

        // TODO: test validations
    }
    
    /**
     * Returns a specific activity in the system.
     *
     * Returns a specific activity in the system
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readActivityTest() throws ApiException {
        String activityId = null;
        String clusterName = null;
        String serviceName = null;
        String view = null;
        ApiActivity response = api.readActivity(activityId, clusterName, serviceName, view);

        // TODO: test validations
    }
    
    /**
     * Returns the child activities.
     *
     * Returns the child activities
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readChildActivitiesTest() throws ApiException {
        String activityId = null;
        String clusterName = null;
        String serviceName = null;
        Integer maxResults = null;
        Integer resultOffset = null;
        String view = null;
        ApiActivityList response = api.readChildActivities(activityId, clusterName, serviceName, maxResults, resultOffset, view);

        // TODO: test validations
    }
    
    /**
     * Returns a list of similar activities.
     *
     * Returns a list of similar activities
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readSimilarActivitiesTest() throws ApiException {
        String activityId = null;
        String clusterName = null;
        String serviceName = null;
        String view = null;
        ApiActivityList response = api.readSimilarActivities(activityId, clusterName, serviceName, view);

        // TODO: test validations
    }
    
}
