/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiCdhUpgradeArgs;
import com.cloudera.api.swagger.model.ApiCluster;
import com.cloudera.api.swagger.model.ApiClusterList;
import com.cloudera.api.swagger.model.ApiClusterPerfInspectorArgs;
import com.cloudera.api.swagger.model.ApiClusterTemplate;
import com.cloudera.api.swagger.model.ApiClusterUtilization;
import com.cloudera.api.swagger.model.ApiCommand;
import com.cloudera.api.swagger.model.ApiCommandList;
import com.cloudera.api.swagger.model.ApiConfigureForKerberosArguments;
import com.cloudera.api.swagger.model.ApiHostRef;
import com.cloudera.api.swagger.model.ApiHostRefList;
import com.cloudera.api.swagger.model.ApiKerberosInfo;
import com.cloudera.api.swagger.model.ApiRestartClusterArgs;
import com.cloudera.api.swagger.model.ApiRollingRestartClusterArgs;
import com.cloudera.api.swagger.model.ApiRollingUpgradeServicesArgs;
import com.cloudera.api.swagger.model.ApiServiceList;
import com.cloudera.api.swagger.model.ApiServiceTypeList;
import java.math.BigDecimal;
import java.io.File;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ClustersResourceApi
 */
@Ignore
public class ClustersResourceApiTest {

    private final ClustersResourceApi api = new ClustersResourceApi();

    
    /**
     * 
     *
     * 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void addHostsTest() throws ApiException {
        String clusterName = null;
        ApiHostRefList body = null;
        ApiHostRefList response = api.addHosts(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Automatically assign roles to hosts and create the roles for all the services in a cluster.
     *
     * Automatically assign roles to hosts and create the roles for all the services in a cluster. &lt;p&gt; Assignments are done based on services and hosts in the cluster, and hardware specifications. If no hosts are added to the cluster, an exception will be thrown preventing any role assignments. Existing roles will be taken into account and their assignments will be not be modified. &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void autoAssignRolesTest() throws ApiException {
        String clusterName = null;
        api.autoAssignRoles(clusterName);

        // TODO: test validations
    }
    
    /**
     * Automatically configures roles and services in a cluster.
     *
     * Automatically configures roles and services in a cluster. &lt;p&gt; Overwrites some existing configurations. Might create new role config groups. Only default role config groups must exist before calling this endpoint. Other role config groups must not exist. If they do, an exception will be thrown preventing any configuration. Ignores the Cloudera Management Service even if colocated with roles of this cluster. To avoid over-committing the heap on hosts, assign hosts to this cluster that are not being used by the Cloudera Management Service. &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void autoConfigureTest() throws ApiException {
        String clusterName = null;
        api.autoConfigure(clusterName);

        // TODO: test validations
    }
    
    /**
     * Configures all services in a cluster to use Auto-TLS.
     *
     * Configures all services in a cluster to use Auto-TLS
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void configureAutoTlsServicesCommandTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.configureAutoTlsServicesCommand(clusterName);

        // TODO: test validations
    }
    
    /**
     * Command to configure the cluster to use Kerberos for authentication.
     *
     * Command to configure the cluster to use Kerberos for authentication.  This command will configure all relevant services on a cluster for Kerberos usage.  This command will trigger a GenerateCredentials command to create Kerberos keytabs for all roles in the cluster.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void configureForKerberosTest() throws ApiException {
        String clusterName = null;
        ApiConfigureForKerberosArguments body = null;
        ApiCommand response = api.configureForKerberos(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Creates a collection of clusters.
     *
     * Creates a collection of clusters.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createClustersTest() throws ApiException {
        ApiClusterList body = null;
        ApiClusterList response = api.createClusters(body);

        // TODO: test validations
    }
    
    /**
     * Deletes a cluster.
     *
     * Deletes a cluster.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteClusterTest() throws ApiException {
        String clusterName = null;
        ApiCluster response = api.deleteCluster(clusterName);

        // TODO: test validations
    }
    
    /**
     * Delete existing Kerberos credentials for the cluster.
     *
     * Delete existing Kerberos credentials for the cluster. &lt;p&gt; This command will affect all services that have been configured to use Kerberos, and have existing credentials.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteClusterCredentialsCommandTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.deleteClusterCredentialsCommand(clusterName);

        // TODO: test validations
    }
    
    /**
     * Deploy the cluster-wide client configuration.
     *
     * Deploy the cluster-wide client configuration.  &lt;p&gt;For each service in the cluster, deploy the service&#39;s client configuration to all the hosts that the service runs on.&lt;/p&gt;  &lt;p&gt;Available since API v2.&lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deployClientConfigTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.deployClientConfig(clusterName);

        // TODO: test validations
    }
    
    /**
     * Deploy the Cluster&#39;s Kerberos client configuration.
     *
     * Deploy the Cluster&#39;s Kerberos client configuration.  &lt;p&gt; Deploy krb5.conf to hosts in a cluster. Does not deploy to decommissioned hosts or hosts with active processes. &lt;/p&gt;  &lt;p&gt; Available since API v7. &lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deployClusterClientConfigTest() throws ApiException {
        String clusterName = null;
        ApiHostRefList body = null;
        ApiCommand response = api.deployClusterClientConfig(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Put the cluster into maintenance mode.
     *
     * Put the cluster into maintenance mode. This is a synchronous command. The result is known immediately upon return.  &lt;p&gt;Available since API v2.&lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void enterMaintenanceModeTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.enterMaintenanceMode(clusterName);

        // TODO: test validations
    }
    
    /**
     * Take the cluster out of maintenance mode.
     *
     * Take the cluster out of maintenance mode. This is a synchronous command. The result is known immediately upon return.  &lt;p&gt;Available since API v2.&lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exitMaintenanceModeTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.exitMaintenanceMode(clusterName);

        // TODO: test validations
    }
    
    /**
     * Remove backup and disaster related log files in hdfs.
     *
     * Remove backup and disaster related log files in hdfs. &lt;p&gt; Available since API v31.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void expireLogsTest() throws ApiException {
        String clusterName = null;
        BigDecimal days = null;
        ApiCommand response = api.expireLogs(clusterName, days);

        // TODO: test validations
    }
    
    /**
     * Export the cluster template for the given cluster.
     *
     * Export the cluster template for the given cluster. If cluster does not have host templates defined it will export host templates based on roles assignment.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exportTest() throws ApiException {
        String clusterName = null;
        Boolean exportAutoConfig = null;
        ApiClusterTemplate response = api.export(clusterName, exportAutoConfig);

        // TODO: test validations
    }
    
    /**
     * Prepare and start services in a cluster.
     *
     * Prepare and start services in a cluster.  &lt;p&gt; Perform all the steps needed to prepare each service in a cluster and start the services in order. &lt;/p&gt;  &lt;p&gt; Available since API v7. &lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void firstRunTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.firstRun(clusterName);

        // TODO: test validations
    }
    
    /**
     * Download a zip-compressed archive of the client configuration, of a specific cluster.
     *
     * Download a zip-compressed archive of the client configuration, of a specific cluster. Currently, this only includes Kerberos Client Configuration (krb5.conf). For client configuration of services, use the clientConfig endpoint of the services resource. This resource does not require any authentication.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getClientConfigTest() throws ApiException {
        String clusterName = null;
        File response = api.getClientConfig(clusterName);

        // TODO: test validations
    }
    
    /**
     * Provides Cluster Kerberos information.
     *
     * Provides Cluster Kerberos information
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getKerberosInfoTest() throws ApiException {
        String clusterName = null;
        ApiKerberosInfo response = api.getKerberosInfo(clusterName);

        // TODO: test validations
    }
    
    /**
     * Provides the resource utilization of the entire cluster as well as the resource utilization per tenant.
     *
     * Provides the resource utilization of the entire cluster as well as the resource utilization per tenant. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getUtilizationReportTest() throws ApiException {
        String clusterName = null;
        List<String> daysOfWeek = null;
        Integer endHourOfDay = null;
        String from = null;
        Integer startHourOfDay = null;
        String tenantType = null;
        String to = null;
        ApiClusterUtilization response = api.getUtilizationReport(clusterName, daysOfWeek, endHourOfDay, from, startHourOfDay, tenantType, to);

        // TODO: test validations
    }
    
    /**
     * Runs the host inspector on the configured hosts in the specified cluster.
     *
     * Runs the host inspector on the configured hosts in the specified cluster.  Available since V8.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void inspectHostsCommandTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.inspectHostsCommand(clusterName);

        // TODO: test validations
    }
    
    /**
     * List active cluster commands.
     *
     * List active cluster commands.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listActiveCommandsTest() throws ApiException {
        String clusterName = null;
        String view = null;
        ApiCommandList response = api.listActiveCommands(clusterName, view);

        // TODO: test validations
    }
    
    /**
     * List the services that can provide distributed file system (DFS) capabilities in this cluster.
     *
     * List the services that can provide distributed file system (DFS) capabilities in this cluster.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listDfsServicesTest() throws ApiException {
        String clusterName = null;
        String view = null;
        ApiServiceList response = api.listDfsServices(clusterName, view);

        // TODO: test validations
    }
    
    /**
     * 
     *
     * 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listHostsTest() throws ApiException {
        String clusterName = null;
        ApiHostRefList response = api.listHosts(clusterName);

        // TODO: test validations
    }
    
    /**
     * List the supported service types for a cluster.
     *
     * List the supported service types for a cluster.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listServiceTypesTest() throws ApiException {
        String clusterName = null;
        ApiServiceTypeList response = api.listServiceTypes(clusterName);

        // TODO: test validations
    }
    
    /**
     * Run cluster performance diagnostics test.
     *
     * Run cluster performance diagnostics test.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void perfInspectorCommandTest() throws ApiException {
        String clusterName = null;
        ApiClusterPerfInspectorArgs body = null;
        ApiCommand response = api.perfInspectorCommand(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Updates all refreshable configuration files for services with Dynamic Resource Pools.
     *
     * Updates all refreshable configuration files for services with Dynamic Resource Pools. &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void poolsRefreshTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.poolsRefresh(clusterName);

        // TODO: test validations
    }
    
    /**
     * Run cluster pre-upgrade check(s) when upgrading from specified version of CDH to the other.
     *
     * Run cluster pre-upgrade check(s) when upgrading from specified version of CDH to the other. &lt;p&gt; Allows the following upgrade checks: &lt;ul&gt; &lt;li&gt;Minor upgrades from any CDH 5 to any CDH 5&lt;/li&gt; &lt;li&gt;Major upgrades from any CDH 5 to any CDH 6&lt;/li&gt; &lt;li&gt;Minor upgrades from any CDH 6 to any CDH 6&lt;/li&gt; &lt;li&gt;Maintenance upgrades or downgrades (a.b.x to a.b.y)&lt;/li&gt; &lt;/ul&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void preUpgradeCheckCommandTest() throws ApiException {
        String clusterName = null;
        ApiCdhUpgradeArgs body = null;
        ApiCommand response = api.preUpgradeCheckCommand(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Reads information about a cluster.
     *
     * Reads information about a cluster.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readClusterTest() throws ApiException {
        String clusterName = null;
        ApiCluster response = api.readCluster(clusterName);

        // TODO: test validations
    }
    
    /**
     * List all known clusters.
     *
     * List all known clusters.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readClustersTest() throws ApiException {
        String clusterType = null;
        String view = null;
        ApiClusterList response = api.readClusters(clusterType, view);

        // TODO: test validations
    }
    
    /**
     * Updates all refreshable configuration files in the cluster.
     *
     * Updates all refreshable configuration files in the cluster. Will not restart any roles. &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void refreshTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.refresh(clusterName);

        // TODO: test validations
    }
    
    /**
     * 
     *
     * 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void removeAllHostsTest() throws ApiException {
        String clusterName = null;
        ApiHostRefList response = api.removeAllHosts(clusterName);

        // TODO: test validations
    }
    
    /**
     * 
     *
     * 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void removeHostTest() throws ApiException {
        String clusterName = null;
        String hostId = null;
        ApiHostRef response = api.removeHost(clusterName, hostId);

        // TODO: test validations
    }
    
    /**
     * Restart all services in the cluster.
     *
     * Restart all services in the cluster. &lt;p&gt; Services are stopped then started in the appropriate order given their dependencies. The command can optionally restart only stale services and their dependencies as well as redeploy client configuration on all services in the cluster.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void restartCommandTest() throws ApiException {
        String clusterName = null;
        ApiRestartClusterArgs body = null;
        ApiCommand response = api.restartCommand(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Command to do a \&quot;best-effort\&quot; rolling restart of the given cluster, i.
     *
     * Command to do a \&quot;best-effort\&quot; rolling restart of the given cluster, i.e. it does plain restart of services that cannot be rolling restarted, followed by first rolling restarting non-slaves and then rolling restarting the slave roles of services that can be rolling restarted. The slave restarts are done host-by-host. &lt;p&gt; Available since API v4. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void rollingRestartTest() throws ApiException {
        String clusterName = null;
        ApiRollingRestartClusterArgs body = null;
        ApiCommand response = api.rollingRestart(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Command to do a rolling upgrade of specific services in the given cluster  This command does not handle any services that don&#39;t support rolling upgrades.
     *
     * Command to do a rolling upgrade of specific services in the given cluster  This command does not handle any services that don&#39;t support rolling upgrades. The command will throw an error and not start if upgrade of any such service is requested.  This command does not upgrade the full CDH Cluster. You should normally use the upgradeCDH Command for upgrading the cluster. This is primarily helpful if you need to need to recover from an upgrade failure or for advanced users to script an alternative to the upgradeCdhCommand.  This command expects the binaries to be available on hosts and activated. It does not change any binaries on the hosts.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void rollingUpgradeTest() throws ApiException {
        String clusterName = null;
        ApiRollingUpgradeServicesArgs body = null;
        ApiCommand response = api.rollingUpgrade(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Start all services in the cluster.
     *
     * Start all services in the cluster. &lt;p&gt; Services are started in the appropriate order given their dependencies.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void startCommandTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.startCommand(clusterName);

        // TODO: test validations
    }
    
    /**
     * Stop all services in the cluster.
     *
     * Stop all services in the cluster. &lt;p&gt; Services are stopped in the appropriate order given their dependencies.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void stopCommandTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.stopCommand(clusterName);

        // TODO: test validations
    }
    
    /**
     * Update an existing cluster.
     *
     * Update an existing cluster. &lt;p&gt; To update the CDH version, provide the new value in the \&quot;fullVersion\&quot; property. Setting a correct version that matches the actual installed software will ensure the correct version-specific features, such as services, roles, commands, and configurations. This need not be manually set for clusters using parcels. In general this action is only necessary after the CDH packages have been manually updated. Note that a downgrade may be rejected if it would render existing services or roles unusable. For major upgrade, the \&quot;upgradeService\&quot; cluster command should be used instead.&lt;/p&gt; &lt;p&gt; To rename the cluster, provide the new name in the \&quot;displayName\&quot; property for API &gt;&#x3D; 6, or in the \&quot;name\&quot; property for API &lt;&#x3D;5. &lt;p&gt; Available since API v2.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateClusterTest() throws ApiException {
        String clusterName = null;
        ApiCluster body = null;
        ApiCluster response = api.updateCluster(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Perform CDH upgrade to the specified version.
     *
     * Perform CDH upgrade to the specified version. &lt;p&gt; Allows the following upgrades: &lt;ul&gt; &lt;li&gt;Major upgrades from any CDH 4 to any CDH 5&lt;/li&gt; &lt;li&gt;Minor upgrades from any CDH 5 to any CDH 5&lt;/li&gt; &lt;li&gt;Maintenance upgrades or downgrades (a.b.x to a.b.y)&lt;/li&gt; &lt;/ul&gt; &lt;p&gt; If using packages, CDH packages on all hosts of the cluster must be manually upgraded before this command is issued. &lt;p&gt; The command will upgrade the services and their configuration to the version available in the CDH5 distribution. &lt;p&gt; Unless rolling upgrade options are provided, the entire cluster will experience downtime. If rolling upgrade options are provided, command will do a \&quot;best-effort\&quot; rolling upgrade of the given cluster, i.e. it does plain upgrade of services that cannot be rolling upgraded, followed by first rolling upgrading non-slaves and then rolling restarting the slave roles of services that can be rolling restarted. The slave restarts are done host-by-host. &lt;p&gt; Available since v9. Rolling upgrade is only available with Cloudera Manager Enterprise Edition. A more limited upgrade variant available since v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void upgradeCdhCommandTest() throws ApiException {
        String clusterName = null;
        ApiCdhUpgradeArgs body = null;
        ApiCommand response = api.upgradeCdhCommand(clusterName, body);

        // TODO: test validations
    }
    
    /**
     * Upgrades the services in the cluster to the CDH5 version.
     *
     * Upgrades the services in the cluster to the CDH5 version. &lt;p&gt; This command requires that the CDH packages in the hosts used by the cluster be upgraded to CDH5 before this command is issued. Once issued, this command will stop all running services before proceeding. &lt;p&gt; If parcels are used instead of CDH system packages then the following steps need to happen in order: &lt;ol&gt; &lt;li&gt;Stop all services manually&lt;/li&gt; &lt;li&gt;Activate parcel&lt;/li&gt; &lt;li&gt;Run this upgrade command&lt;/li&gt; &lt;/ol&gt; The command will upgrade the services and their configuration to the version available in the CDH5 distribution.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void upgradeServicesCommandTest() throws ApiException {
        String clusterName = null;
        ApiCommand response = api.upgradeServicesCommand(clusterName);

        // TODO: test validations
    }
    
}
