/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiCommand;
import com.cloudera.api.swagger.model.ApiCommandMetadataList;
import com.cloudera.api.swagger.model.ApiConfigList;
import com.cloudera.api.swagger.model.ApiExternalAccount;
import com.cloudera.api.swagger.model.ApiExternalAccountCategoryList;
import com.cloudera.api.swagger.model.ApiExternalAccountList;
import com.cloudera.api.swagger.model.ApiExternalAccountTypeList;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ExternalAccountsResourceApi
 */
@Ignore
public class ExternalAccountsResourceApiTest {

    private final ExternalAccountsResourceApi api = new ExternalAccountsResourceApi();

    
    /**
     * Create a new external account.
     *
     * Create a new external account. Account names and display names must be unique, i.e. they must not share names or display names with an existing account. Server generates an account ID for the requested account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createAccountTest() throws ApiException {
        ApiExternalAccount body = null;
        ApiExternalAccount response = api.createAccount(body);

        // TODO: test validations
    }
    
    /**
     * Delete an external account, specifying its name.
     *
     * Delete an external account, specifying its name.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteAccountTest() throws ApiException {
        String name = null;
        ApiExternalAccount response = api.deleteAccount(name);

        // TODO: test validations
    }
    
    /**
     * Executes a command on the external account specified by name.
     *
     * Executes a command on the external account specified by name. &lt;p&gt; Available since API v16.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void externalAccountCommandByNameTest() throws ApiException {
        String commandName = null;
        String name = null;
        ApiCommand response = api.externalAccountCommandByName(commandName, name);

        // TODO: test validations
    }
    
    /**
     * List of external account categories supported by this Cloudera Manager.
     *
     * List of external account categories supported by this Cloudera Manager.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSupportedCategoriesTest() throws ApiException {
        ApiExternalAccountCategoryList response = api.getSupportedCategories();

        // TODO: test validations
    }
    
    /**
     * List of external account types supported by this Cloudera Manager by category.
     *
     * List of external account types supported by this Cloudera Manager by category.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSupportedTypesTest() throws ApiException {
        String categoryName = null;
        ApiExternalAccountTypeList response = api.getSupportedTypes(categoryName);

        // TODO: test validations
    }
    
    /**
     * Lists all the commands that can be executed by name on the provided external account type.
     *
     * Lists all the commands that can be executed by name on the provided external account type. &lt;p&gt; Available since API v16.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listExternalAccountCommandsTest() throws ApiException {
        String typeName = null;
        ApiCommandMetadataList response = api.listExternalAccountCommands(typeName);

        // TODO: test validations
    }
    
    /**
     * Get a single external account by account name.
     *
     * Get a single external account by account name.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readAccountTest() throws ApiException {
        String name = null;
        String view = null;
        ApiExternalAccount response = api.readAccount(name, view);

        // TODO: test validations
    }
    
    /**
     * Get a single external account by display name.
     *
     * Get a single external account by display name.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readAccountByDisplayNameTest() throws ApiException {
        String displayName = null;
        String view = null;
        ApiExternalAccount response = api.readAccountByDisplayName(displayName, view);

        // TODO: test validations
    }
    
    /**
     * Get a list of external accounts for a specific account type.
     *
     * Get a list of external accounts for a specific account type.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readAccountsTest() throws ApiException {
        String typeName = null;
        String view = null;
        ApiExternalAccountList response = api.readAccounts(typeName, view);

        // TODO: test validations
    }
    
    /**
     * Get configs of external account for the given account name.
     *
     * Get configs of external account for the given account name.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readConfigTest() throws ApiException {
        String name = null;
        String view = null;
        ApiConfigList response = api.readConfig(name, view);

        // TODO: test validations
    }
    
    /**
     * Update an external account.
     *
     * Update an external account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateAccountTest() throws ApiException {
        ApiExternalAccount body = null;
        ApiExternalAccount response = api.updateAccount(body);

        // TODO: test validations
    }
    
    /**
     * Upadate configs of external account for the given account name.
     *
     * Upadate configs of external account for the given account name.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateConfigTest() throws ApiException {
        String name = null;
        String message = null;
        ApiConfigList body = null;
        ApiConfigList response = api.updateConfig(name, message, body);

        // TODO: test validations
    }
    
}
