/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiCommand;
import com.cloudera.api.swagger.model.ApiConfigList;
import com.cloudera.api.swagger.model.ApiGenerateHostCertsArguments;
import com.cloudera.api.swagger.model.ApiHost;
import com.cloudera.api.swagger.model.ApiHostList;
import com.cloudera.api.swagger.model.ApiMetricList;
import com.cloudera.api.swagger.model.ApiMigrateRolesArguments;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for HostsResourceApi
 */
@Ignore
public class HostsResourceApiTest {

    private final HostsResourceApi api = new HostsResourceApi();

    
    /**
     * .
     *
     * &lt;p&gt;Create one or more hosts.&lt;/p&gt; &lt;p&gt;You must specify at least the hostname and ipAddress in the request objects. If no hostId is specified, it will be set to the hostname.  It is an error to try and create host with the same hostId as another host.&lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createHostsTest() throws ApiException {
        ApiHostList body = null;
        ApiHostList response = api.createHosts(body);

        // TODO: test validations
    }
    
    /**
     * Delete all hosts in the system.
     *
     * Delete all hosts in the system
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteAllHostsTest() throws ApiException {
        ApiHostList response = api.deleteAllHosts();

        // TODO: test validations
    }
    
    /**
     * Delete a host from the system.
     *
     * Delete a host from the system
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteHostTest() throws ApiException {
        String hostId = null;
        ApiHost response = api.deleteHost(hostId);

        // TODO: test validations
    }
    
    /**
     * Put the host into maintenance mode.
     *
     * Put the host into maintenance mode. This is a synchronous command. The result is known immediately upon return.  &lt;p&gt;Available since API v2.&lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void enterMaintenanceModeTest() throws ApiException {
        String hostId = null;
        ApiCommand response = api.enterMaintenanceMode(hostId);

        // TODO: test validations
    }
    
    /**
     * Take the host out of maintenance mode.
     *
     * Take the host out of maintenance mode. This is a synchronous command. The result is known immediately upon return.  &lt;p&gt; Available since API v2. &lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exitMaintenanceModeTest() throws ApiException {
        String hostId = null;
        ApiCommand response = api.exitMaintenanceMode(hostId);

        // TODO: test validations
    }
    
    /**
     * Generates (or regenerates) a key and certificate for this host if Auto-TLS is enabled.
     *
     * Generates (or regenerates) a key and certificate for this host if Auto-TLS is enabled.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void generateHostCertsTest() throws ApiException {
        String hostId = null;
        ApiGenerateHostCertsArguments body = null;
        ApiCommand response = api.generateHostCerts(hostId, body);

        // TODO: test validations
    }
    
    /**
     * Fetch metric readings for a host.
     *
     * Fetch metric readings for a host. &lt;p&gt; By default, this call will look up all metrics available for the host. If only specific metrics are desired, use the &lt;i&gt;metrics&lt;/i&gt; parameter. &lt;p&gt; By default, the returned results correspond to a 5 minute window based on the provided end time (which defaults to the current server time). The &lt;i&gt;from&lt;/i&gt; and &lt;i&gt;to&lt;/i&gt; parameters can be used to control the window being queried. A maximum window of 3 hours is enforced. &lt;p&gt; When requesting a \&quot;full\&quot; view, aside from the extended properties of the returned metric data, the collection will also contain information about all metrics available for the role, even if no readings are available in the requested window. &lt;p&gt; Host metrics also include per-network interface and per-storage device metrics. Since collecting this data incurs in more overhead, query parameters can be used to choose which network interfaces and storage devices to query, or to these metrics altogether. &lt;p&gt; Storage metrics are collected at different levels; for example, per-disk and per-partition metrics are available. The \&quot;storageIds\&quot; parameter can be used to filter specific storage IDs. &lt;p&gt; In the returned data, the network interfaces and storage IDs can be identified by looking at the \&quot;context\&quot; property of the metric objects.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getMetricsTest() throws ApiException {
        String hostId = null;
        String from = null;
        List<String> ifs = null;
        List<String> metrics = null;
        Boolean queryNw = null;
        Boolean queryStorage = null;
        List<String> storageIds = null;
        String to = null;
        String view = null;
        ApiMetricList response = api.getMetrics(hostId, from, ifs, metrics, queryNw, queryStorage, storageIds, to, view);

        // TODO: test validations
    }
    
    /**
     * Migrate roles to a different host.
     *
     * Migrate roles to a different host. &lt;p&gt; This command applies only to HDFS NameNode, JournalNode, and Failover Controller roles. In order to migrate these roles: &lt;ul&gt; &lt;li&gt;HDFS High Availability must be enabled, using quorum-based storage.&lt;/li&gt; &lt;li&gt;HDFS must not be configured to use a federated nameservice.&lt;/li&gt; &lt;/ul&gt; &lt;b&gt;Migrating a NameNode or JournalNode role requires cluster downtime&lt;/b&gt;. HDFS, along with all of its dependent services, will be stopped at the beginning of the migration process, and restarted at its conclusion. &lt;p&gt;If the active NameNode is selected for migration, a manual failover will be performed before the role is migrated. The role will remain in standby mode after the migration is complete. &lt;p&gt;When migrating a NameNode role, the co-located Failover Controller role must be migrated as well if automatic failover is enabled. The Failover Controller role name must be included in the list of role names to migrate specified in the arguments to this command (it will not be included implicitly). This command does not allow a Failover Controller role to be moved by itself, although it is possible to move a JournalNode independently. &lt;p&gt; Available since API v10.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void migrateRolesTest() throws ApiException {
        String hostId = null;
        ApiMigrateRolesArguments body = null;
        ApiCommand response = api.migrateRoles(hostId, body);

        // TODO: test validations
    }
    
    /**
     * Returns a specific Host in the system.
     *
     * Returns a specific Host in the system.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readHostTest() throws ApiException {
        String hostId = null;
        String view = null;
        ApiHost response = api.readHost(hostId, view);

        // TODO: test validations
    }
    
    /**
     * Retrieves the configuration of a specific host.
     *
     * Retrieves the configuration of a specific host.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readHostConfigTest() throws ApiException {
        String hostId = null;
        String view = null;
        ApiConfigList response = api.readHostConfig(hostId, view);

        // TODO: test validations
    }
    
    /**
     * Returns the hostIds for all hosts in the system.
     *
     * Returns the hostIds for all hosts in the system.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readHostsTest() throws ApiException {
        String view = null;
        ApiHostList response = api.readHosts(view);

        // TODO: test validations
    }
    
    /**
     * .
     *
     * &lt;p&gt;Update an existing host in the system.&lt;/p&gt; &lt;p&gt;Currently, only updating the rackId is supported.  All other fields of the host will be ignored.&lt;/p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateHostTest() throws ApiException {
        String hostId = null;
        ApiHost body = null;
        ApiHost response = api.updateHost(hostId, body);

        // TODO: test validations
    }
    
    /**
     * Updates the host configuration with the given values.
     *
     * Updates the host configuration with the given values. &lt;p&gt; If a value is set in the given configuration, it will be added to the host&#39;s configuration, replacing any existing entries. If a value is unset (its value is null), the existing configuration for the attribute will be erased, if any. &lt;p&gt; Attributes that are not listed in the input will maintain their current values in the configuration.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateHostConfigTest() throws ApiException {
        String hostId = null;
        String message = null;
        ApiConfigList body = null;
        ApiConfigList response = api.updateHostConfig(hostId, message, body);

        // TODO: test validations
    }
    
}
