/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiImpalaCancelResponse;
import com.cloudera.api.swagger.model.ApiImpalaQueryAttributeList;
import com.cloudera.api.swagger.model.ApiImpalaQueryDetailsResponse;
import com.cloudera.api.swagger.model.ApiImpalaQueryResponse;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ImpalaQueriesResourceApi
 */
@Ignore
public class ImpalaQueriesResourceApiTest {

    private final ImpalaQueriesResourceApi api = new ImpalaQueriesResourceApi();

    
    /**
     * Cancels an Impala Query.
     *
     * Cancels an Impala Query. &lt;p&gt; Available since API v4.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void cancelImpalaQueryTest() throws ApiException {
        String clusterName = null;
        String queryId = null;
        String serviceName = null;
        ApiImpalaCancelResponse response = api.cancelImpalaQuery(clusterName, queryId, serviceName);

        // TODO: test validations
    }
    
    /**
     * Returns a list of queries that satisfy the filter.
     *
     * Returns a list of queries that satisfy the filter &lt;p&gt; Available since API v4.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImpalaQueriesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String filter = null;
        String from = null;
        Integer limit = null;
        Integer offset = null;
        String to = null;
        ApiImpalaQueryResponse response = api.getImpalaQueries(clusterName, serviceName, filter, from, limit, offset, to);

        // TODO: test validations
    }
    
    /**
     * Returns the list of all attributes that the Service Monitor can associate with Impala queries.
     *
     * Returns the list of all attributes that the Service Monitor can associate with Impala queries. &lt;p&gt; Examples of attributes include the user who issued the query and the number of HDFS bytes read by the query. &lt;p&gt; These attributes can be used to search for specific Impala queries through the getImpalaQueries API. For example the &#39;user&#39; attribute could be used in the search &#39;user &#x3D; root&#39;. If the attribute is numeric it can also be used as a metric in a tsquery (ie, &#39;select hdfs_bytes_read from IMPALA_QUERIES&#39;). &lt;p&gt; Note that this response is identical for all Impala services. &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImpalaQueryAttributesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiImpalaQueryAttributeList response = api.getImpalaQueryAttributes(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Returns details about the query.
     *
     * Returns details about the query. Not all queries have details, check the detailsAvailable field from the getQueries response. &lt;p&gt; Available since API v4.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getQueryDetailsTest() throws ApiException {
        String clusterName = null;
        String queryId = null;
        String serviceName = null;
        String format = null;
        ApiImpalaQueryDetailsResponse response = api.getQueryDetails(clusterName, queryId, serviceName, format);

        // TODO: test validations
    }
    
}
