/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v33</h1>       <p>Introduced in Cloudera Manager 6.3.1</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 6.3.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiYarnApplicationAttributeList;
import com.cloudera.api.swagger.model.ApiYarnApplicationResponse;
import com.cloudera.api.swagger.model.ApiYarnKillResponse;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for YarnApplicationsResourceApi
 */
@Ignore
public class YarnApplicationsResourceApiTest {

    private final YarnApplicationsResourceApi api = new YarnApplicationsResourceApi();

    
    /**
     * Returns the list of all attributes that the Service Monitor can associate with YARN applications.
     *
     * Returns the list of all attributes that the Service Monitor can associate with YARN applications. &lt;p&gt; Examples of attributes include the user who ran the application and the number of maps completed by the application. &lt;p&gt; These attributes can be used to search for specific YARN applications through the getYarnApplications API. For example the &#39;user&#39; attribute could be used in the search &#39;user &#x3D; root&#39;. If the attribute is numeric it can also be used as a metric in a tsquery (ie, &#39;select maps_completed from YARN_APPLICATIONS&#39;). &lt;p&gt; Note that this response is identical for all YARN services. &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getYarnApplicationAttributesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiYarnApplicationAttributeList response = api.getYarnApplicationAttributes(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Returns a list of applications that satisfy the filter.
     *
     * Returns a list of applications that satisfy the filter &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getYarnApplicationsTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String filter = null;
        String from = null;
        Integer limit = null;
        Integer offset = null;
        String to = null;
        ApiYarnApplicationResponse response = api.getYarnApplications(clusterName, serviceName, filter, from, limit, offset, to);

        // TODO: test validations
    }
    
    /**
     * Kills an YARN Application.
     *
     * Kills an YARN Application &lt;p&gt; Available since API v6.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void killYarnApplicationTest() throws ApiException {
        String applicationId = null;
        String clusterName = null;
        String serviceName = null;
        ApiYarnKillResponse response = api.killYarnApplication(applicationId, clusterName, serviceName);

        // TODO: test validations
    }
    
}
